Package: DuoClustering2018
Type: Package
Title: Data, Clustering Results and Visualization Functions From Duò et
        al (2018)
Version: 1.28.0
Author: Angelo Duò, Charlotte Soneson
Maintainer: Angelo Duò <angelo.duo@icloud.com>
Description: Preprocessed experimental and simulated scRNA-seq data sets used 
    for evaluation of clustering methods for scRNA-seq data in 
    Duò et al (2018). Also contains results from applying several clustering 
    methods to each of the data sets, and functions for plotting method 
    performance.
License: GPL (>=2)
Encoding: UTF-8
biocViews: SingleCellData, ExperimentData
Imports: ExperimentHub, utils, magrittr, dplyr, tidyr, mclust, ggplot2,
        purrr, reshape2, viridis, ggthemes, stats, methods
Suggests: knitr, rmarkdown, BiocStyle, iSEE, scater,
        SingleCellExperiment, SummarizedExperiment, plyr
VignetteBuilder: knitr
RoxygenNote: 6.1.0
git_url: https://git.bioconductor.org/packages/DuoClustering2018
git_branch: RELEASE_3_22
git_last_commit: 3a6eb6f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-11-06
NeedsCompilation: no
Packaged: 2025-11-06 16:17:47 UTC; biocbuild

# DuoClustering2018
R package with data sets and clustering results from Duò et al (F1000Research 2018). See  https://doi.org/10.12688/F1000RESEARCH.15666.1 for the paper. The package is available from https://bioconductor.org/packages/DuoClustering2018.
To install the package use the following commands in R:
```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("DuoClustering2018", version = "devel")
```

#' Plot differences between optimal, estimated and true number of clusters
#'
#' @param res A data.frame with clustering results.
#' @param method_colors A named vector with colors to use for the different
#'   clustering methods. Can be NULL, in which case colors are chosen
#'   automatically.
#'
#' @export
#'
#' @author Angelo Duo, Charlotte Soneson
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr group_by summarize select ungroup filter mutate
#' @importFrom tidyr separate
#' @importFrom mclust adjustedRandIndex
#' @importFrom ggplot2 scale_colour_manual theme element_text facet_wrap
#'   geom_boxplot geom_dotplot aes labs ggplot geom_hline scale_colour_discrete
#'   theme_bw
#' @importFrom stats median na.omit
#'
#' @return A named list of ggplot2 objects
#'
#' @examples
#' res <- clustering_summary_filteredExpr10_Koh_v2()
#' plots <- plot_k_diff(res)
#'
plot_k_diff <- function(res, method_colors = NULL) {
  ## Initialize list to hold plots
  plots <- list()

  if (is.null(method_colors)) {
    manual_scale <- ggplot2::scale_colour_discrete(name = "")
  } else {
    manual_scale <- ggplot2::scale_colour_manual(name = "",
                                                 values = method_colors)
  }

  shared_theme <- list(
    ggplot2::theme_bw(),
    manual_scale,
    ggplot2::theme(legend.text = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   axis.title = ggplot2::element_text(size = 16),
                   axis.text = ggplot2::element_text(size = 13),
                   strip.text = ggplot2::element_text(size = 13),
                   legend.position = "none"),
    ggplot2::facet_wrap(~ filtering, scales = "free"),
    ggplot2::geom_hline(yintercept = 0, linetype = "dashed"),
    ggplot2::geom_boxplot(outlier.color = NA, alpha = 0.5),
    ggplot2::geom_dotplot(binaxis = "y", stackdir = "center",
                          dotsize = 0.2, stackratio = 1)
  )

  ## Compute ARI, true number of clusters, estimated number of clusters,
  ## elapsed time
  res_summary <- res %>%
    dplyr::group_by(dataset, method, run, k) %>%
    dplyr::summarize(ARI = mclust::adjustedRandIndex(cluster, trueclass),
                     truenclust = length(unique(trueclass)),
                     estnclust = unique(est_k),
                     elapsed = stats::median(elapsed)) %>%
    tidyr::separate(dataset, sep = "_", into = c("sce", "filtering",
                                                 "dataset")) %>%
    dplyr::select(-sce) %>% dplyr::ungroup()

  ## Calculate the difference between the k that gives the maximal ARI and the
  ## true k
  diff_abs <- res_summary %>%
    dplyr::group_by(dataset, filtering, method, truenclust, k) %>%
    dplyr::summarize(medARI = stats::median(ARI, na.rm = TRUE)) %>%
    dplyr::filter(medARI == max(medARI, na.rm = TRUE)) %>%
    dplyr::mutate(k_diff = (k - truenclust))

  plots[["diff_kmax_ktrue"]] <-
    ggplot2::ggplot(diff_abs,
                    ggplot2::aes(x = method, y = k_diff, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::labs(y = paste("Difference between number of clusters giving ",
                            "\nmaximal ARI and true number of clusters"),
                  x = "", title = "") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                       hjust = 1, vjust = 0.5))

  ## Calculate the difference between the estimated and true number of clusters
  diff_estnclust <- res_summary %>%
    dplyr::filter(k == truenclust) %>%
    dplyr::group_by(method, dataset, filtering, estnclust, truenclust) %>%
    dplyr::summarize(k_diff = unique(estnclust) - unique(truenclust)) %>%
    dplyr::ungroup()
  diff_estnclust$method <- factor(diff_estnclust$method)

  plots[["diff_kest_ktrue"]] <-
    ggplot2::ggplot(stats::na.omit(diff_estnclust),
                    ggplot2::aes(x = method, y = k_diff, color = method)) +
    shared_theme +
    ggplot2::labs(y = paste0("Difference between estimated and ",
                             "true number of clusters"),
                  x = "", title = "") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                       hjust = 1, vjust = 0.5))

  plots
}

#' @importFrom utils read.csv
.onLoad <- function(libname, pkgname) {
  fl <- system.file("extdata", "metadata.csv", package = "DuoClustering2018")
  titles <- utils::read.csv(fl, stringsAsFactors = FALSE)$Title
  ExperimentHub::createHubAccessors(pkgname, titles)
}

#' Plot timing of methods
#'
#' Plot the elapsed time for each clustering method
#'
#' @param res A data.frame with clustering results.
#' @param method_colors A named vector with colors to use for the different
#'   clustering methods. Can be NULL, in which case colors are chosen
#'   automatically.
#' @param scaleMethod Either NULL or one of the clustering methods in the result
#'   data.frame. If not NULL, a plot will be generated where all elapsed times
#'   are normalized by dividing with the time for \code{scaleMethod}. If NULL,
#'   this plot will not be generated.
#'
#' @export
#'
#' @author Angelo Duo, Charlotte Soneson
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr group_by summarize select ungroup
#' @importFrom tidyr separate
#' @importFrom mclust adjustedRandIndex
#' @importFrom ggplot2 scale_colour_manual geom_boxplot geom_line facet_grid
#'   scale_y_log10 theme_bw labs theme element_text aes
#' @importFrom stats median
#'
#' @return A named list of ggplot2 objects
#'
#' @examples
#' res <- clustering_summary_filteredExpr10_Koh_v2()
#' plots <- plot_timing(res)
#'
plot_timing <- function(res, method_colors = NULL, scaleMethod = NULL) {
  ## Initialize list to hold plots
  plots <- list()

  if (is.null(method_colors)) {
    manual_scale <- ggplot2::scale_colour_discrete(name = "")
  } else {
    manual_scale <- ggplot2::scale_colour_manual(name = "",
                                                 values = method_colors)
  }

  shared_theme <- list(
    ggplot2::scale_y_log10(),
    ggplot2::theme_bw(),
    manual_scale,
    ggplot2::theme(legend.text = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   axis.title = ggplot2::element_text(size = 16),
                   axis.text.y = ggplot2::element_text(size = 13),
                   axis.text.x = ggplot2::element_text(size = 13),
                   strip.text = ggplot2::element_text(size = 13))
  )

  ## Compute ARI, true number of clusters, estimated number of clusters,
  ## elapsed time
  res_summary <- res %>%
    dplyr::group_by(dataset, method, run, k) %>%
    dplyr::summarize(ARI = mclust::adjustedRandIndex(cluster, trueclass),
                     truenclust = length(unique(trueclass)),
                     estnclust = unique(est_k),
                     elapsed = stats::median(elapsed)) %>%
    tidyr::separate(dataset, sep = "_", into = c("sce", "filtering",
                                                 "dataset")) %>%
    dplyr::select(-sce) %>% dplyr::ungroup()

  ## Elapsed time, one boxplot per dataset, over all ks and runs
  plots[["time_boxplot"]] <-
    ggplot2::ggplot(res_summary,
                    ggplot2::aes(x = reorder(method, elapsed,
                                             FUN = stats::median,
                                             order = TRUE, na.rm = TRUE),
                                 y = elapsed, group = method, color = method)) +
    shared_theme +
    ggplot2::geom_boxplot() +
    ggplot2::facet_grid(filtering ~ dataset, scales = "free") +
    ggplot2::labs(title = "", x = "", y = "Elapsed time (s)") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                       vjust = 0.5, hjust = 1),
                   legend.position = "none")

  ## Elapsed time, normalized by median time for scaleMethod
  if (!is.null(scaleMethod) && scaleMethod %in% res$method) {
    median.ref <- res_summary %>%
      dplyr::select(filtering, dataset, method, k, run, truenclust, elapsed) %>%
      dplyr::group_by(dataset, filtering, k) %>%
      dplyr::filter(method == scaleMethod) %>%
      dplyr::summarise(med.t = stats::median(elapsed)) %>%
      dplyr::ungroup()
    res.time <- res_summary %>%
      dplyr::group_by(filtering, dataset, method, k) %>%
      dplyr::summarise(median.elapsed = stats::median(elapsed))%>%
      dplyr::ungroup()
    res.time <- dplyr::full_join(res.time, median.ref,
                                 by = c("dataset", "filtering", "k")) %>%
      dplyr::mutate(norm.time = median.elapsed/med.t)

    plots[["time_normalized_by_ref"]] <-
      ggplot2::ggplot(res.time,
                      ggplot2::aes(x = reorder(method, norm.time,
                                               FUN = stats::median,
                                               order = TRUE, na.rm = TRUE),
                                   y = norm.time, group = method,
                                   color = method)) +
      shared_theme +
      ggplot2::geom_boxplot() +
      ggplot2::labs(x = "", y = paste0("Run time, normalized by ",
                                       scaleMethod), size = 16)+
      ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                         vjust = 0.5,
                                                         hjust = 1),
                     legend.position = "none")
  }

  plots[["time_vs_k"]] <-
    ggplot2::ggplot(res_summary %>% dplyr::group_by(dataset, filtering,
                                                    method, k) %>%
                      dplyr::summarize(
                        medianelapsed = stats::median(elapsed)) %>%
                      dplyr::ungroup(),
                    ggplot2::aes(x = k, y = medianelapsed, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_line(size = 1) +
    ggplot2::facet_grid(filtering ~ dataset, scales = "free") +
    ggplot2::labs(title = "", y = "Elapsed time (s)",
                  x = "Number of clusters") +
    ggplot2::theme(legend.position = "right")

  plots
}

#' Calculate Shannon entropy
#'
#' @param cluster_assignments A vector with cluster assignments
#'
#' @return The Shannon entropy of the assignment vector
#'
shannon_entropy <- function(cluster_assignments) {
  p <- c(table(cluster_assignments)) / length(cluster_assignments)
  -1 * sum(p * log2(p))
}

#' Plot entropy of cluster assignments
#'
#' @param res A data.frame with clustering results.
#' @param method_colors A named vector with colors to use for the different
#'   clustering methods. Can be NULL, in which case colors are chosen
#'   automatically.
#'
#' @export
#'
#' @author Angelo Duo, Charlotte Soneson
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr group_by summarize select ungroup filter mutate
#' @importFrom tidyr separate
#' @importFrom mclust adjustedRandIndex
#' @importFrom ggplot2 scale_colour_manual scale_colour_discrete theme_bw theme
#'   element_text aes ggplot geom_line facet_grid geom_vline geom_point labs
#'   geom_hline geom_point geom_boxplot
#' @importFrom stats median
#'
#' @return A named list of ggplot2 objects
#'
#' @examples
#' res <- clustering_summary_filteredExpr10_Koh_v2()
#' plots <- plot_entropy(res)
#'
plot_entropy <- function(res, method_colors = NULL) {
  ## Initialize list to hold plots
  plots <- list()

  if (is.null(method_colors)) {
    manual_scale <- ggplot2::scale_colour_discrete(name = "")
  } else {
    manual_scale <- ggplot2::scale_colour_manual(name = "",
                                                 values = method_colors)
  }

  shared_theme <- list(
    ggplot2::theme_bw(),
    manual_scale,
    ggplot2::theme(legend.text = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   axis.title = ggplot2::element_text(size = 16),
                   axis.text.y = ggplot2::element_text(size = 13),
                   axis.text.x = ggplot2::element_text(size = 13),
                   strip.text = ggplot2::element_text(size = 13))
  )

  ## Compute entropy and ARI
  res_entropy <- res %>%
    dplyr::group_by(dataset, method, run, k) %>%
    dplyr::filter(!is.na(cluster)) %>%
    dplyr::summarize(s = shannon_entropy(cluster),
                     s.true = shannon_entropy(trueclass),
                     s.norm = s/log2(unique(k)),
                     s.true.norm = s.true/log2(unique(k)),
                     ARI = mclust::adjustedRandIndex(cluster, trueclass),
                     truenclust = length(unique(trueclass)),
                     estnclust = unique(est_k)
    ) %>%
    tidyr::separate(dataset, sep = "_", into = c("sce", "filtering",
                                                 "dataset")) %>%
    dplyr::select(-sce) %>%
    dplyr::ungroup()

  # plot entropy per k
  plots[["entropy_vs_k"]] <-
    ggplot2::ggplot(data = res_entropy %>%
                      dplyr::filter(!is.na(s)) %>%
                      dplyr::group_by(dataset, method, filtering, k,
                                      truenclust, s.true) %>%
                      dplyr::summarize(
                        entropy = stats::median(s, na.rm = TRUE)),
                    ggplot2::aes(x = k, y = entropy, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_line(size = 1) +
    ggplot2::facet_grid(filtering ~ dataset, scale = "free_x") +
    ggplot2::geom_vline(aes(xintercept = truenclust), linetype = "dashed") +
    ggplot2::geom_point(aes(x = truenclust, y = s.true), color = 1, shape = 4) +
    ggplot2::labs(x = "Number of clusters", y = "Entropy")  +
    ggplot2::theme(legend.position = "right")

  plots[["entropy_vs_ari"]] <-
    ggplot2::ggplot(data = res_entropy %>%
                      dplyr::filter(k == truenclust),
                    ggplot2::aes(x = ARI, y = s, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_point() +
    ggplot2::facet_grid(filtering ~ dataset, scale = "free") +
    ggplot2::geom_hline(aes(yintercept = s.true), linetype = "dashed") +
    ggplot2::labs(x = "ARI", y = "Entropy")

  plots[["normentropy"]] <-
    ggplot2::ggplot(data = res_entropy %>%
                      dplyr::filter(k == truenclust),
                    ggplot2::aes(x = method, y = s.norm, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_boxplot() +
    ggplot2::facet_grid(. ~ dataset, scale = "free") +
    ggplot2::geom_hline(aes(yintercept = s.true.norm), linetype = "dashed") +
    ggplot2::labs(x = "",
                  y = "Normalized Entropy for true number of clusters") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, size = 13,
                                                       vjust = 0.5, hjust = 1),
                   legend.position = "none")

  # Difference to truth at truenclust
  plots[["deltaentropy_truek"]] <-
    ggplot2::ggplot(data = res_entropy %>%
                      dplyr::filter(k == truenclust) %>%
                      dplyr::mutate(ds = s - s.true),
                    ggplot2::aes(x = method, y = ds, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_boxplot() +
    ggplot2::geom_hline(aes(yintercept = 0), linetype = "dashed") +
    ggplot2::facet_grid(. ~ dataset, scale = "free") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, size = 13,
                                                       vjust = 0.5, hjust = 1),
                   legend.position = "none") +
    ggplot2::labs(x = "",
                  y = paste("Difference between entropy for clustering",
                            " and truth, \nfor true number of clusters"))

  # Difference to truth at truenclust, normalized entropy
  plots[["deltanormentropy_truek"]] <-
    ggplot2::ggplot(data = res_entropy %>%
                      dplyr::filter(k == truenclust) %>%
                      dplyr::mutate(ds.norm = s.norm - s.true.norm),
                    ggplot2::aes(x = method, y = ds.norm, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_boxplot() +
    ggplot2::geom_hline(aes(yintercept = 0), linetype = "dashed") +
    ggplot2::theme(legend.position = "none",
                   axis.text.x = ggplot2::element_text(angle = 90, size = 13,
                                                       vjust = 0.5,
                                                       hjust = 1)) +
    ggplot2::labs(x = "", y = paste("Difference between normalised entropy ",
                                    "\nfor clustering and truth, for true ",
                                    "number of clusters"))

  plots
}

#' Plot performance of clustering methods
#'
#' Generate various plots of the agreement between each clustering and the true
#' partitioning of the cells, quantified by the adjusted Rand index (ARI).
#'
#' @param res A data.frame with clustering results.
#' @param method_colors A named vector with colors to use for the different
#'   clustering methods. Can be NULL, in which case colors are chosen
#'   automatically.
#'
#' @export
#'
#' @author Angelo Duo, Charlotte Soneson
#'
#' @importFrom ggplot2 scale_colour_manual scale_y_log10 theme_bw element_text
#'   aes theme ggplot geom_tile facet_wrap labs coord_equal element_blank
#'   geom_line geom_vline facet_grid geom_point ggtitle guides unit
#' @importFrom dplyr group_by summarize select ungroup
#' @importFrom tidyr separate
#' @importFrom mclust adjustedRandIndex
#' @importFrom stats reorder
#' @importFrom viridis scale_fill_viridis
#' @importFrom ggthemes theme_tufte
#' @importFrom stats median
#'
#' @return A named list of \code{ggplot2} objects
#'
#' @examples
#' res <- clustering_summary_filteredExpr10_Koh_v2()
#' plots <- plot_performance(res)
#'
plot_performance <- function(res, method_colors = NULL) {
  ## Initialize list to hold plots
  plots <- list()

  if (is.null(method_colors)) {
    manual_scale <- ggplot2::scale_colour_discrete(name = "")
  } else {
    manual_scale <- ggplot2::scale_colour_manual(name = "",
                                                 values = method_colors)
  }

  shared_theme <- list(
    ggplot2::theme_bw(),
    manual_scale,
    ggplot2::theme(legend.text = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   axis.title = ggplot2::element_text(size = 16),
                   axis.text = ggplot2::element_text(size = 13),
                   strip.text = ggplot2::element_text(size = 13))
  )

  shared_theme_heatmap <- list(
    ggplot2::geom_tile(color = "white", size = 0.5, na.rm = FALSE),
    ggplot2::facet_wrap(~ filtering),
    viridis::scale_fill_viridis(name = "Median ARI", direction = -1,
                                na.value = "white"),
    ggthemes::theme_tufte(base_family = "Helvetica"),
    ggplot2::labs(x = NULL, y = NULL, title = ""),
    ggplot2::coord_equal(),
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                       hjust = 1, vjust = 0.5),
                   axis.text.y = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   legend.title.align = 1,
                   legend.text = ggplot2::element_text(size = 13),
                   legend.position = "right",
                   legend.key.size = ggplot2::unit(2, "cm"),
                   legend.key.width = ggplot2::unit(0.5, "cm"),
                   axis.ticks = ggplot2::element_blank(),
                   strip.text = ggplot2::element_text(size = 13))
  )

  res_summary <- res %>%
    dplyr::group_by(dataset, method, run, k) %>%
    dplyr::summarize(ARI = mclust::adjustedRandIndex(cluster, trueclass),
                     truenclust = length(unique(trueclass)),
                     estnclust = unique(est_k),
                     elapsed = stats::median(elapsed)) %>%
    tidyr::separate(dataset, sep = "_", into = c("sce", "filtering",
                                                 "dataset")) %>%
    dplyr::select(-sce) %>% dplyr::ungroup()

  ## ARI plots
  ## Median ARI vs k
  plots[["median_ari_vs_k"]] <-
    ggplot2::ggplot(res_summary %>%
                      dplyr::group_by(dataset, filtering, method, k) %>%
                      dplyr::summarize(
                        medianARI = stats::median(ARI, na.rm = TRUE),
                        truenclust = unique(truenclust)) %>%
                      dplyr::ungroup(),
                    ggplot2::aes(x = k, y = medianARI, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_vline(aes(xintercept = truenclust), linetype = "dashed") +
    ggplot2::geom_line(size = 1) +
    ggplot2::facet_grid(filtering ~ dataset, scales = "free_x") +
    ggplot2::labs(title = "", x = "Number of clusters",
                  y = "Median Adjusted Rand Index") +
    ggplot2::theme(legend.position = "right")

  ## Scatter plots -- time versus ARI
  plots[["scatter_time_vs_ari_truek"]] <-
    ggplot2::ggplot(res_summary %>% dplyr::filter(k == truenclust),
                    ggplot2::aes(x = ARI, y = elapsed, color = method,
                                 shape = filtering)) +
    shared_theme +
    ggplot2::geom_point(size = 6, alpha = 0.8) +
    ggplot2::scale_y_log10() +
    ggplot2::facet_wrap(~ dataset, scales = "free") +
    ggplot2::labs(y = "Elapsed time (s)", x = "Adjusted Rand Index") +
    ggplot2::guides(color = ggplot2::guide_legend(""),
                    shape = ggplot2::guide_legend(""))

  ## Heatmap of median ARI at true k
  plots[["median_ari_heatmap_truek"]] <-
    ggplot2::ggplot(res_summary %>%
                      dplyr::filter(k == truenclust) %>%
                      dplyr::group_by(dataset, filtering, method, k) %>%
                      dplyr::summarize(
                        medianARI = stats::median(ARI, na.rm = TRUE)),
                    ggplot2::aes(x = stats::reorder(method, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 y = stats::reorder(dataset, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 fill = medianARI)) +
    shared_theme_heatmap +
    ggplot2::ggtitle("Median ARI, true number of clusters")

  ## Heatmap of median ARI at k giving best performance
  plots[["median_ari_heatmap_bestk"]] <-
    ggplot2::ggplot(res_summary %>%
                      dplyr::group_by(dataset, filtering, method, k) %>%
                      dplyr::summarize(
                        medianARI = stats::median(ARI, na.rm = TRUE)) %>%
                      dplyr::group_by(dataset, filtering, method) %>%
                      dplyr::filter(medianARI == max(medianARI, na.rm = TRUE)),
                    ggplot2::aes(x = stats::reorder(method, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 y = stats::reorder(dataset, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 fill = medianARI)) +
    shared_theme_heatmap +
    ggplot2::ggtitle("Median ARI, number of clusters giving highest ARI")

  ## Heatmap of ARI at estimated number of clusters
  plots[["median_ari_heatmap_estk"]] <-
    ggplot2::ggplot(res_summary %>%
                      dplyr::filter(k == estnclust) %>%
                      dplyr::group_by(dataset, filtering, method, k) %>%
                      dplyr::summarize(medianARI = stats::median(ARI)),
                    ggplot2::aes(x = stats::reorder(method, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 y = stats::reorder(dataset, medianARI,
                                                    FUN = mean, na.rm = TRUE),
                                 fill = medianARI)) +
    shared_theme_heatmap +
    ggplot2::ggtitle("Median ARI, estimated number of clusters")

  plots
}

## --------------------------- parameter values ----------------------------- ##
df_all_parameter_settings_v1 <- data.frame(
  Title = "duo_clustering_all_parameter_settings_v1",
  Description = "Hyperparameter values used for all clustering algorithms and data sets in v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = NA,
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = NA,
  TaxonomyId = NA,
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "list",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/parameter_settings/all_parameter_settings_v1.rds",
  stringsAsFactors = FALSE
)
df_all_parameter_settings_v2 <- data.frame(
  Title = "duo_clustering_all_parameter_settings_v2",
  Description = "Hyperparameter values used for all clustering algorithms and data sets in v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = NA,
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = NA,
  TaxonomyId = NA,
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "list",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/parameter_settings/all_parameter_settings_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------------- full_Koh --------------------------------- ##
df_sce_full_Koh <- data.frame(
  Title = "sce_full_Koh",
  Description = "Gene counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Koh.rds",
  stringsAsFactors = FALSE
)

## -------------------------- filteredExpr10_Koh ---------------------------- ##
df_sce_filteredExpr10_Koh <- data.frame(
  Title = "sce_filteredExpr10_Koh",
  Description = "Gene counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Koh.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Koh_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Koh_v1",
  Description = "Clustering results for sce_filteredExpr10_Koh, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Koh_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Koh_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Koh_v2",
  Description = "Clustering results for sce_filteredExpr10_Koh, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Koh_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------------- filteredHVG10_Koh ----------------------------- ##
df_sce_filteredHVG10_Koh <- data.frame(
  Title = "sce_filteredHVG10_Koh",
  Description = "Gene counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Koh.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Koh_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Koh_v1",
  Description = "Clustering results for sce_filteredHVG10_Koh, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Koh_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Koh_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Koh_v2",
  Description = "Clustering results for sce_filteredHVG10_Koh, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Koh_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------- filteredM3Drop10_Koh --------------------------- ##
df_sce_filteredM3Drop10_Koh <- data.frame(
  Title = "sce_filteredM3Drop10_Koh",
  Description = "Gene counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Koh.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Koh_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Koh_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Koh, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Koh_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Koh_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Koh_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Koh, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Koh_v2.rds",
  stringsAsFactors = FALSE
)
## ----------------------------- full_KohTCC -------------------------------- ##
df_sce_full_KohTCC <- data.frame(
  Title = "sce_full_KohTCC",
  Description = "TCC counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. All TCCs except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_KohTCC.rds",
  stringsAsFactors = FALSE
)

## ------------------------ filteredExpr10_KohTCC --------------------------- ##
df_sce_filteredExpr10_KohTCC <- data.frame(
  Title = "sce_filteredExpr10_KohTCC",
  Description = "TCC counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% TCCs with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_KohTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_KohTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_KohTCC_v1",
  Description = "Clustering results for sce_filteredExpr10_KohTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_KohTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_KohTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_KohTCC_v2",
  Description = "Clustering results for sce_filteredExpr10_KohTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_KohTCC_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------ filteredHVG10_KohTCC ---------------------------- ##
df_sce_filteredHVG10_KohTCC <- data.frame(
  Title = "sce_filteredHVG10_KohTCC",
  Description = "TCC counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% most highly variable TCCs are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_KohTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_KohTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_KohTCC_v1",
  Description = "Clustering results for sce_filteredHVG10_KohTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_KohTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_KohTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_KohTCC_v2",
  Description = "Clustering results for sce_filteredHVG10_KohTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_KohTCC_v2.rds",
  stringsAsFactors = FALSE
)
## ----------------------- filteredM3Drop10_KohTCC -------------------------- ##
df_sce_filteredM3Drop10_KohTCC <- data.frame(
  Title = "sce_filteredM3Drop10_KohTCC",
  Description = "TCC counts for scRNA-seq data set of in vitro cultured H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm progenitors. The top 10% TCCs ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/sra?term=SRP073808",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "SRA (SRP073808), Koh et al. (2016)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_KohTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_KohTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_KohTCC_v1",
  Description = "Clustering results for sce_filteredM3Drop10_KohTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_KohTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_KohTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_KohTCC_v2",
  Description = "Clustering results for sce_filteredM3Drop10_KohTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_KohTCC_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------------ full_Kumar -------------------------------- ##
df_sce_full_Kumar <- data.frame(
  Title = "sce_full_Kumar",
  Description = "Gene counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Kumar.rds",
  stringsAsFactors = FALSE
)

## ------------------------- filteredExpr10_Kumar --------------------------- ##
df_sce_filteredExpr10_Kumar <- data.frame(
  Title = "sce_filteredExpr10_Kumar",
  Description = "Gene counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Kumar.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Kumar_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Kumar_v1",
  Description = "Clustering results for sce_filteredExpr10_Kumar, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Kumar_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Kumar_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Kumar_v2",
  Description = "Clustering results for sce_filteredExpr10_Kumar, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Kumar_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------- filteredHVG10_Kumar ---------------------------- ##
df_sce_filteredHVG10_Kumar <- data.frame(
  Title = "sce_filteredHVG10_Kumar",
  Description = "Gene counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Kumar.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Kumar_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Kumar_v1",
  Description = "Clustering results for sce_filteredHVG10_Kumar, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Kumar_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Kumar_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Kumar_v2",
  Description = "Clustering results for sce_filteredHVG10_Kumar, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Kumar_v2.rds",
  stringsAsFactors = FALSE
)
## ------------------------ filteredM3Drop10_Kumar -------------------------- ##
df_sce_filteredM3Drop10_Kumar <- data.frame(
  Title = "sce_filteredM3Drop10_Kumar",
  Description = "Gene counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Kumar.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Kumar_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Kumar_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Kumar, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Kumar_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Kumar_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Kumar_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Kumar, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Kumar_v2.rds",
  stringsAsFactors = FALSE
)
## ---------------------------- full_KumarTCC ------------------------------- ##
df_sce_full_KumarTCC <- data.frame(
  Title = "sce_full_KumarTCC",
  Description = "TCC counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. All TCCs except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_KumarTCC.rds",
  stringsAsFactors = FALSE
)

## ----------------------- filteredExpr10_KumarTCC -------------------------- ##
df_sce_filteredExpr10_KumarTCC <- data.frame(
  Title = "sce_filteredExpr10_KumarTCC",
  Description = "TCC counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% TCCs with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_KumarTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_KumarTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_KumarTCC_v1",
  Description = "Clustering results for sce_filteredExpr10_KumarTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_KumarTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_KumarTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_KumarTCC_v2",
  Description = "Clustering results for sce_filteredExpr10_KumarTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_KumarTCC_v2.rds",
  stringsAsFactors = FALSE
)
## ----------------------- filteredHVG10_KumarTCC --------------------------- ##
df_sce_filteredHVG10_KumarTCC <- data.frame(
  Title = "sce_filteredHVG10_KumarTCC",
  Description = "TCC counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% most highly variable TCCs are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_KumarTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_KumarTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_KumarTCC_v1",
  Description = "Clustering results for sce_filteredHVG10_KumarTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_KumarTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_KumarTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_KumarTCC_v2",
  Description = "Clustering results for sce_filteredHVG10_KumarTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_KumarTCC_v2.rds",
  stringsAsFactors = FALSE
)
## ---------------------- filteredM3Drop10_KumarTCC ------------------------- ##
df_sce_filteredM3Drop10_KumarTCC <- data.frame(
  Title = "sce_filteredM3Drop10_KumarTCC",
  Description = "TCC counts for scRNA-seq data set of mESCs with various genetic perturbations, cultured in different media. The top 10% TCCs ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE60749",
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE60749), Kumar et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_KumarTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_KumarTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_KumarTCC_v1",
  Description = "Clustering results for sce_filteredM3Drop10_KumarTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_KumarTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_KumarTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_KumarTCC_v2",
  Description = "Clustering results for sce_filteredM3Drop10_KumarTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_KumarTCC_v2.rds",
  stringsAsFactors = FALSE
)

## ---------------------------- full_Trapnell ------------------------------- ##
df_sce_full_Trapnell <- data.frame(
  Title = "sce_full_Trapnell",
  Description = "Gene counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Trapnell.rds",
  stringsAsFactors = FALSE
)

## ----------------------- filteredExpr10_Trapnell -------------------------- ##
df_sce_filteredExpr10_Trapnell <- data.frame(
  Title = "sce_filteredExpr10_Trapnell",
  Description = "Gene counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Trapnell.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Trapnell_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Trapnell_v1",
  Description = "Clustering results for sce_filteredExpr10_Trapnell, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Trapnell_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Trapnell_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Trapnell_v2",
  Description = "Clustering results for sce_filteredExpr10_Trapnell, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Trapnell_v2.rds",
  stringsAsFactors = FALSE
)
## ----------------------- filteredHVG10_Trapnell --------------------------- ##
df_sce_filteredHVG10_Trapnell <- data.frame(
  Title = "sce_filteredHVG10_Trapnell",
  Description = "Gene counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Trapnell.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Trapnell_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Trapnell_v1",
  Description = "Clustering results for sce_filteredHVG10_Trapnell, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Trapnell_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Trapnell_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Trapnell_v2",
  Description = "Clustering results for sce_filteredHVG10_Trapnell, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Trapnell_v2.rds",
  stringsAsFactors = FALSE
)
## ---------------------- filteredM3Drop10_Trapnell ------------------------- ##
df_sce_filteredM3Drop10_Trapnell <- data.frame(
  Title = "sce_filteredM3Drop10_Trapnell",
  Description = "Gene counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Trapnell.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Trapnell_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Trapnell_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Trapnell, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Trapnell_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Trapnell_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Trapnell_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Trapnell, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Trapnell_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------------- full_TrapnellTCC ------------------------------ ##
df_sce_full_TrapnellTCC <- data.frame(
  Title = "sce_full_TrapnellTCC",
  Description = "TCC counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. All TCCs except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_TrapnellTCC.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredExpr10_TrapnellTCC ------------------------- ##
df_sce_filteredExpr10_TrapnellTCC <- data.frame(
  Title = "sce_filteredExpr10_TrapnellTCC",
  Description = "TCC counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% TCCs with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_TrapnellTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_TrapnellTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_TrapnellTCC_v1",
  Description = "Clustering results for sce_filteredExpr10_TrapnellTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_TrapnellTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_TrapnellTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_TrapnellTCC_v2",
  Description = "Clustering results for sce_filteredExpr10_TrapnellTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_TrapnellTCC_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredHVG10_TrapnellTCC -------------------------- ##
df_sce_filteredHVG10_TrapnellTCC <- data.frame(
  Title = "sce_filteredHVG10_TrapnellTCC",
  Description = "TCC counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% most highly variable TCCs are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_TrapnellTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_TrapnellTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_TrapnellTCC_v1",
  Description = "Clustering results for sce_filteredHVG10_TrapnellTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_TrapnellTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_TrapnellTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_TrapnellTCC_v2",
  Description = "Clustering results for sce_filteredHVG10_TrapnellTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_TrapnellTCC_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------- filteredM3Drop10_TrapnellTCC ------------------------ ##
df_sce_filteredM3Drop10_TrapnellTCC <- data.frame(
  Title = "sce_filteredM3Drop10_TrapnellTCC",
  Description = "TCC counts for scRNA-seq data set of primary myoblasts over a time course of serum-induced differentiation. The top 10% TCCs ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "FASTQ",
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "GEO (GSE52529), Trapnell et al. (2014)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_TrapnellTCC.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_TrapnellTCC_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_TrapnellTCC_v1",
  Description = "Clustering results for sce_filteredM3Drop10_TrapnellTCC, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_TrapnellTCC_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_TrapnellTCC_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_TrapnellTCC_v2",
  Description = "Clustering results for sce_filteredM3Drop10_TrapnellTCC, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCh38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_TrapnellTCC_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------------- full_Zhengmix4eq ----------------------------- ##
df_sce_full_Zhengmix4eq <- data.frame(
  Title = "sce_full_Zhengmix4eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in equal proportions. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Zhengmix4eq.rds",
  stringsAsFactors = FALSE
)

## ---------------------- filteredExpr10_Zhengmix4eq ------------------------ ##
df_sce_filteredExpr10_Zhengmix4eq <- data.frame(
  Title = "sce_filteredExpr10_Zhengmix4eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in equal proportions. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Zhengmix4eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix4eq_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix4eq_v1",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix4eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix4eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix4eq_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix4eq_v2",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix4eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix4eq_v2.rds",
  stringsAsFactors = FALSE
)
## ---------------------- filteredHVG10_Zhengmix4eq ------------------------- ##
df_sce_filteredHVG10_Zhengmix4eq <- data.frame(
  Title = "sce_filteredHVG10_Zhengmix4eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in equal proportions. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Zhengmix4eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix4eq_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix4eq_v1",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix4eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix4eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix4eq_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix4eq_v2",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix4eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix4eq_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredM3Drop10_Zhengmix4eq ----------------------- ##
df_sce_filteredM3Drop10_Zhengmix4eq <- data.frame(
  Title = "sce_filteredM3Drop10_Zhengmix4eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in equal proportions. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Zhengmix4eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix4eq_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix4eq_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix4eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix4eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix4eq_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix4eq_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix4eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix4eq_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------------- full_Zhengmix4uneq ---------------------------- ##
df_sce_full_Zhengmix4uneq <- data.frame(
  Title = "sce_full_Zhengmix4uneq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in unequal proportions. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Zhengmix4uneq.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredExpr10_Zhengmix4uneq ----------------------- ##
df_sce_filteredExpr10_Zhengmix4uneq <- data.frame(
  Title = "sce_filteredExpr10_Zhengmix4uneq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in unequal proportions. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Zhengmix4uneq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix4uneq_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix4uneq_v1",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix4uneq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix4uneq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix4uneq_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix4uneq_v2",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix4uneq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix4uneq_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredHVG10_Zhengmix4uneq ------------------------ ##
df_sce_filteredHVG10_Zhengmix4uneq <- data.frame(
  Title = "sce_filteredHVG10_Zhengmix4uneq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in unequal proportions. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Zhengmix4uneq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix4uneq_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix4uneq_v1",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix4uneq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix4uneq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix4uneq_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix4uneq_v2",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix4uneq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix4uneq_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------- filteredM3Drop10_Zhengmix4uneq ---------------------- ##
df_sce_filteredM3Drop10_Zhengmix4uneq <- data.frame(
  Title = "sce_filteredM3Drop10_Zhengmix4uneq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, CD14 monocytes, naive cytotoxic T-cells and regulatory T-cells in unequal proportions. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Zhengmix4uneq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix4uneq_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix4uneq_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix4uneq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix4uneq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix4uneq_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix4uneq_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix4uneq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix4uneq_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------------- full_Zhengmix8eq ----------------------------- ##
df_sce_full_Zhengmix8eq <- data.frame(
  Title = "sce_full_Zhengmix8eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, naive cytotoxic T-cells, CD14 monocytes, regulatory T-cells, CD56 NK cells, memory T-cells, CD4 T-helper cells and naive T-cells in approximately equal proportions. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_Zhengmix8eq.rds",
  stringsAsFactors = FALSE
)

## ---------------------- filteredExpr10_Zhengmix8eq ------------------------ ##
df_sce_filteredExpr10_Zhengmix8eq <- data.frame(
  Title = "sce_filteredExpr10_Zhengmix8eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, naive cytotoxic T-cells, CD14 monocytes, regulatory T-cells, CD56 NK cells, memory T-cells, CD4 T-helper cells and naive T-cells in approximately equal proportions. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_Zhengmix8eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix8eq_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix8eq_v1",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix8eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix8eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_Zhengmix8eq_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_Zhengmix8eq_v2",
  Description = "Clustering results for sce_filteredExpr10_Zhengmix8eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_Zhengmix8eq_v2.rds",
  stringsAsFactors = FALSE
)
## ---------------------- filteredHVG10_Zhengmix8eq ------------------------- ##
df_sce_filteredHVG10_Zhengmix8eq <- data.frame(
  Title = "sce_filteredHVG10_Zhengmix8eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, naive cytotoxic T-cells, CD14 monocytes, regulatory T-cells, CD56 NK cells, memory T-cells, CD4 T-helper cells and naive T-cells in approximately equal proportions. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_Zhengmix8eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix8eq_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix8eq_v1",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix8eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix8eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_Zhengmix8eq_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_Zhengmix8eq_v2",
  Description = "Clustering results for sce_filteredHVG10_Zhengmix8eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_Zhengmix8eq_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredM3Drop10_Zhengmix8eq ----------------------- ##
df_sce_filteredM3Drop10_Zhengmix8eq <- data.frame(
  Title = "sce_filteredM3Drop10_Zhengmix8eq",
  Description = "UMI counts for scRNA-seq data set consisting of sorted B-cells, naive cytotoxic T-cells, CD14 monocytes, regulatory T-cells, CD56 NK cells, memory T-cells, CD4 T-helper cells and naive T-cells in approximately equal proportions. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "TXT",
  SourceUrl = "https://support.10xgenomics.com/single-cell-gene-expression/datasets",
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "10x Genomics, Zheng et al (2017)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_Zhengmix8eq.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix8eq_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix8eq_v1",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix8eq, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix8eq_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_Zhengmix8eq_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_Zhengmix8eq_v2",
  Description = "Clustering results for sce_filteredM3Drop10_Zhengmix8eq, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "hg19",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Homo sapiens",
  TaxonomyId = "9606",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_Zhengmix8eq_v2.rds",
  stringsAsFactors = FALSE
)
## -------------------------- full_SimKumar4easy ---------------------------- ##
df_sce_full_SimKumar4easy <- data.frame(
  Title = "sce_full_SimKumar4easy",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_SimKumar4easy.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredExpr10_SimKumar4easy ----------------------- ##
df_sce_filteredExpr10_SimKumar4easy <- data.frame(
  Title = "sce_filteredExpr10_SimKumar4easy",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_SimKumar4easy.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar4easy_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar4easy_v1",
  Description = "Clustering results for sce_filteredExpr10_SimKumar4easy, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar4easy_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar4easy_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar4easy_v2",
  Description = "Clustering results for sce_filteredExpr10_SimKumar4easy, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar4easy_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredHVG10_SimKumar4easy ------------------------ ##
df_sce_filteredHVG10_SimKumar4easy <- data.frame(
  Title = "sce_filteredHVG10_SimKumar4easy",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_SimKumar4easy.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar4easy_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar4easy_v1",
  Description = "Clustering results for sce_filteredHVG10_SimKumar4easy, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar4easy_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar4easy_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar4easy_v2",
  Description = "Clustering results for sce_filteredHVG10_SimKumar4easy, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar4easy_v2.rds",
  stringsAsFactors = FALSE
)

## -------------------- filteredM3Drop10_SimKumar4easy ---------------------- ##
df_sce_filteredM3Drop10_SimKumar4easy <- data.frame(
  Title = "sce_filteredM3Drop10_SimKumar4easy",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_SimKumar4easy.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar4easy_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar4easy_v1",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar4easy, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar4easy_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar4easy_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar4easy_v2",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar4easy, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar4easy_v2.rds",
  stringsAsFactors = FALSE
)

## -------------------------- full_SimKumar4hard ---------------------------- ##
df_sce_full_SimKumar4hard <- data.frame(
  Title = "sce_full_SimKumar4hard",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_SimKumar4hard.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredExpr10_SimKumar4hard ----------------------- ##
df_sce_filteredExpr10_SimKumar4hard <- data.frame(
  Title = "sce_filteredExpr10_SimKumar4hard",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_SimKumar4hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar4hard_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar4hard_v1",
  Description = "Clustering results for sce_filteredExpr10_SimKumar4hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar4hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar4hard_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar4hard_v2",
  Description = "Clustering results for sce_filteredExpr10_SimKumar4hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar4hard_v2.rds",
  stringsAsFactors = FALSE
)
## --------------------- filteredHVG10_SimKumar4hard ------------------------ ##
df_sce_filteredHVG10_SimKumar4hard <- data.frame(
  Title = "sce_filteredHVG10_SimKumar4hard",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_SimKumar4hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar4hard_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar4hard_v1",
  Description = "Clustering results for sce_filteredHVG10_SimKumar4hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar4hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar4hard_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar4hard_v2",
  Description = "Clustering results for sce_filteredHVG10_SimKumar4hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar4hard_v2.rds",
  stringsAsFactors = FALSE
)

## -------------------- filteredM3Drop10_SimKumar4hard ---------------------- ##
df_sce_filteredM3Drop10_SimKumar4hard <- data.frame(
  Title = "sce_filteredM3Drop10_SimKumar4hard",
  Description = "Gene counts for simulated scRNA-seq data set with four subpopulations. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_SimKumar4hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar4hard_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar4hard_v1",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar4hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar4hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar4hard_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar4hard_v2",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar4hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar4hard_v2.rds",
  stringsAsFactors = FALSE
)

## -------------------------- full_SimKumar8hard ---------------------------- ##
df_sce_full_SimKumar8hard <- data.frame(
  Title = "sce_full_SimKumar8hard",
  Description = "Gene counts for simulated scRNA-seq data set with eight subpopulations. All genes except those with zero counts across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_full/sce_full_SimKumar8hard.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredExpr10_SimKumar8hard ----------------------- ##
df_sce_filteredExpr10_SimKumar8hard <- data.frame(
  Title = "sce_filteredExpr10_SimKumar8hard",
  Description = "Gene counts for simulated scRNA-seq data set with eight subpopulations. The top 10% genes with the highest average expression across all cells are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredExpr10/sce_filteredExpr10_SimKumar8hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar8hard_v1 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar8hard_v1",
  Description = "Clustering results for sce_filteredExpr10_SimKumar8hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar8hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredExpr10_SimKumar8hard_v2 <- data.frame(
  Title = "clustering_summary_filteredExpr10_SimKumar8hard_v2",
  Description = "Clustering results for sce_filteredExpr10_SimKumar8hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredExpr10_SimKumar8hard_v2.rds",
  stringsAsFactors = FALSE
)

## --------------------- filteredHVG10_SimKumar8hard ------------------------ ##
df_sce_filteredHVG10_SimKumar8hard <- data.frame(
  Title = "sce_filteredHVG10_SimKumar8hard",
  Description = "Gene counts for simulated scRNA-seq data set with eight subpopulations. The top 10% most highly variable genes are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredHVG10/sce_filteredHVG10_SimKumar8hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar8hard_v1 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar8hard_v1",
  Description = "Clustering results for sce_filteredHVG10_SimKumar8hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar8hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredHVG10_SimKumar8hard_v2 <- data.frame(
  Title = "clustering_summary_filteredHVG10_SimKumar8hard_v2",
  Description = "Clustering results for sce_filteredHVG10_SimKumar8hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredHVG10_SimKumar8hard_v2.rds",
  stringsAsFactors = FALSE
)

## -------------------- filteredM3Drop10_SimKumar8hard ---------------------- ##
df_sce_filteredM3Drop10_SimKumar8hard <- data.frame(
  Title = "sce_filteredM3Drop10_SimKumar8hard",
  Description = "Gene counts for simulated scRNA-seq data set with eight subpopulations. The top 10% genes ranked by z-scores from the M3Drop package are retained.",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "SingleCellExperiment",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/data/sce_filteredM3Drop10/sce_filteredM3Drop10_SimKumar8hard.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar8hard_v1 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar8hard_v1",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar8hard, corresponding to v1 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar8hard_v1.rds",
  stringsAsFactors = FALSE
)

df_res_filteredM3Drop10_SimKumar8hard_v2 <- data.frame(
  Title = "clustering_summary_filteredM3Drop10_SimKumar8hard_v2",
  Description = "Clustering results for sce_filteredM3Drop10_SimKumar8hard, corresponding to v2 of Duo et al (F1000Research 2018)",
  BiocVersion = "3.8",
  Genome = "GRCm38",
  SourceType = "rds",
  SourceUrl = NA,
  SourceVersion = NA,
  Species = "Mus musculus",
  TaxonomyId = "10090",
  Coordinate_1_based = NA,
  DataProvider = "Robinson group (UZH)",
  Maintainer = "Angelo Duo <angelo.duo@icloud.com>",
  RDataClass = "data.frame",
  DispatchClass = "Rds",
  RDataPath = "DuoClustering2018/output/clustering_summary_filteredM3Drop10_SimKumar8hard_v2.rds",
  stringsAsFactors = FALSE
)

## Combined meta-data
df_all <- base::rbind(
  df_all_parameter_settings_v1,
  df_all_parameter_settings_v2,
  df_sce_full_Koh,
  df_sce_filteredExpr10_Koh,
  df_sce_filteredHVG10_Koh,
  df_sce_filteredM3Drop10_Koh,
  df_sce_full_KohTCC,
  df_sce_filteredExpr10_KohTCC,
  df_sce_filteredHVG10_KohTCC,
  df_sce_filteredM3Drop10_KohTCC,
  df_sce_full_Kumar,
  df_sce_filteredExpr10_Kumar,
  df_sce_filteredHVG10_Kumar,
  df_sce_filteredM3Drop10_Kumar,
  df_sce_full_KumarTCC,
  df_sce_filteredExpr10_KumarTCC,
  df_sce_filteredHVG10_KumarTCC,
  df_sce_filteredM3Drop10_KumarTCC,
  df_sce_full_Trapnell,
  df_sce_filteredExpr10_Trapnell,
  df_sce_filteredHVG10_Trapnell,
  df_sce_filteredM3Drop10_Trapnell,
  df_sce_full_TrapnellTCC,
  df_sce_filteredExpr10_TrapnellTCC,
  df_sce_filteredHVG10_TrapnellTCC,
  df_sce_filteredM3Drop10_TrapnellTCC,
  df_sce_full_Zhengmix4eq,
  df_sce_filteredExpr10_Zhengmix4eq,
  df_sce_filteredHVG10_Zhengmix4eq,
  df_sce_filteredM3Drop10_Zhengmix4eq,
  df_sce_full_Zhengmix4uneq,
  df_sce_filteredExpr10_Zhengmix4uneq,
  df_sce_filteredHVG10_Zhengmix4uneq,
  df_sce_filteredM3Drop10_Zhengmix4uneq,
  df_sce_full_Zhengmix8eq,
  df_sce_filteredExpr10_Zhengmix8eq,
  df_sce_filteredHVG10_Zhengmix8eq,
  df_sce_filteredM3Drop10_Zhengmix8eq,
  df_sce_full_SimKumar4easy,
  df_sce_filteredExpr10_SimKumar4easy,
  df_sce_filteredHVG10_SimKumar4easy,
  df_sce_filteredM3Drop10_SimKumar4easy,
  df_sce_full_SimKumar4hard,
  df_sce_filteredExpr10_SimKumar4hard,
  df_sce_filteredHVG10_SimKumar4hard,
  df_sce_filteredM3Drop10_SimKumar4hard,
  df_sce_full_SimKumar8hard,
  df_sce_filteredExpr10_SimKumar8hard,
  df_sce_filteredHVG10_SimKumar8hard,
  df_sce_filteredM3Drop10_SimKumar8hard,
  df_res_filteredExpr10_Koh_v1,
  df_res_filteredHVG10_Koh_v1,
  df_res_filteredM3Drop10_Koh_v1,
  df_res_filteredExpr10_KohTCC_v1,
  df_res_filteredHVG10_KohTCC_v1,
  df_res_filteredM3Drop10_KohTCC_v1,
  df_res_filteredExpr10_Kumar_v1,
  df_res_filteredHVG10_Kumar_v1,
  df_res_filteredM3Drop10_Kumar_v1,
  df_res_filteredExpr10_KumarTCC_v1,
  df_res_filteredHVG10_KumarTCC_v1,
  df_res_filteredM3Drop10_KumarTCC_v1,
  df_res_filteredExpr10_Trapnell_v1,
  df_res_filteredHVG10_Trapnell_v1,
  df_res_filteredM3Drop10_Trapnell_v1,
  df_res_filteredExpr10_TrapnellTCC_v1,
  df_res_filteredHVG10_TrapnellTCC_v1,
  df_res_filteredM3Drop10_TrapnellTCC_v1,
  df_res_filteredExpr10_Zhengmix4eq_v1,
  df_res_filteredHVG10_Zhengmix4eq_v1,
  df_res_filteredM3Drop10_Zhengmix4eq_v1,
  df_res_filteredExpr10_Zhengmix4uneq_v1,
  df_res_filteredHVG10_Zhengmix4uneq_v1,
  df_res_filteredM3Drop10_Zhengmix4uneq_v1,
  df_res_filteredExpr10_Zhengmix8eq_v1,
  df_res_filteredHVG10_Zhengmix8eq_v1,
  df_res_filteredM3Drop10_Zhengmix8eq_v1,
  df_res_filteredExpr10_SimKumar4easy_v1,
  df_res_filteredHVG10_SimKumar4easy_v1,
  df_res_filteredM3Drop10_SimKumar4easy_v1,
  df_res_filteredExpr10_SimKumar4hard_v1,
  df_res_filteredHVG10_SimKumar4hard_v1,
  df_res_filteredM3Drop10_SimKumar4hard_v1,
  df_res_filteredExpr10_SimKumar8hard_v1,
  df_res_filteredHVG10_SimKumar8hard_v1,
  df_res_filteredM3Drop10_SimKumar8hard_v1,
  df_res_filteredExpr10_Koh_v2,
  df_res_filteredHVG10_Koh_v2,
  df_res_filteredM3Drop10_Koh_v2,
  df_res_filteredExpr10_KohTCC_v2,
  df_res_filteredHVG10_KohTCC_v2,
  df_res_filteredM3Drop10_KohTCC_v2,
  df_res_filteredExpr10_Kumar_v2,
  df_res_filteredHVG10_Kumar_v2,
  df_res_filteredM3Drop10_Kumar_v2,
  df_res_filteredExpr10_KumarTCC_v2,
  df_res_filteredHVG10_KumarTCC_v2,
  df_res_filteredM3Drop10_KumarTCC_v2,
  df_res_filteredExpr10_Trapnell_v2,
  df_res_filteredHVG10_Trapnell_v2,
  df_res_filteredM3Drop10_Trapnell_v2,
  df_res_filteredExpr10_TrapnellTCC_v2,
  df_res_filteredHVG10_TrapnellTCC_v2,
  df_res_filteredM3Drop10_TrapnellTCC_v2,
  df_res_filteredExpr10_Zhengmix4eq_v2,
  df_res_filteredHVG10_Zhengmix4eq_v2,
  df_res_filteredM3Drop10_Zhengmix4eq_v2,
  df_res_filteredExpr10_Zhengmix4uneq_v2,
  df_res_filteredHVG10_Zhengmix4uneq_v2,
  df_res_filteredM3Drop10_Zhengmix4uneq_v2,
  df_res_filteredExpr10_Zhengmix8eq_v2,
  df_res_filteredHVG10_Zhengmix8eq_v2,
  df_res_filteredM3Drop10_Zhengmix8eq_v2,
  df_res_filteredExpr10_SimKumar4easy_v2,
  df_res_filteredHVG10_SimKumar4easy_v2,
  df_res_filteredM3Drop10_SimKumar4easy_v2,
  df_res_filteredExpr10_SimKumar4hard_v2,
  df_res_filteredHVG10_SimKumar4hard_v2,
  df_res_filteredM3Drop10_SimKumar4hard_v2,
  df_res_filteredExpr10_SimKumar8hard_v2,
  df_res_filteredHVG10_SimKumar8hard_v2,
  df_res_filteredM3Drop10_SimKumar8hard_v2
)

## Save .csv file
write.csv(df_all, file = "../extdata/metadata.csv", row.names = FALSE)

## -----------------------------------------------------------------------------
suppressPackageStartupMessages({
  library(DuoClustering2018)
})

scename <- "sce_filteredExpr10_Koh"
sce <- sce_filteredExpr10_Koh()
method <- "PCAHC"

## -----------------------------------------------------------------------------
## Load parameter files. General dataset and method parameters as well as
## dataset/method-specific parameters
params <- duo_clustering_all_parameter_settings_v2()[[paste0(scename, "_", 
                                                             method)]]
params

## ----eval=FALSE---------------------------------------------------------------
# ## Set number of times to run clustering for each k
# n_rep <- 5
# 
# ## Run clustering
# set.seed(1234)
# L <- lapply(seq_len(n_rep), function(i) {  ## For each run
#   cat(paste0("run = ", i, "\n"))
#   if (method == "Seurat") {
#     tmp <- lapply(params$range_resolutions, function(resolution) {
#       ## For each resolution
#       cat(paste0("resolution = ", resolution, "\n"))
#       ## Run clustering
#       res <- get(paste0("apply_", method))(sce = sce, params = params,
#                                            resolution = resolution)
# 
#       ## Put output in data frame
#       df <- data.frame(dataset = scename,
#                        method = method,
#                        cell = names(res$cluster),
#                        run = i,
#                        k = length(unique(res$cluster)),
#                        resolution = resolution,
#                        cluster = res$cluster,
#                        stringsAsFactors = FALSE, row.names = NULL)
#       tm <- data.frame(dataset = scename,
#                        method = method,
#                        run = i,
#                        k = length(unique(res$cluster)),
#                        resolution = resolution,
#                        user.self = res$st[["user.self"]],
#                        sys.self = res$st[["sys.self"]],
#                        user.child = res$st[["user.child"]],
#                        sys.child = res$st[["sys.child"]],
#                        elapsed = res$st[["elapsed"]],
#                        stringsAsFactors = FALSE, row.names = NULL)
#       kest <- data.frame(dataset = scename,
#                          method = method,
#                          run = i,
#                          k = length(unique(res$cluster)),
#                          resolution = resolution,
#                          est_k = res$est_k,
#                          stringsAsFactors = FALSE, row.names = NULL)
#       list(clusters = df, timing = tm, kest = kest)
#     })  ## End for each resolution
#   } else {
#     tmp <- lapply(params$range_clusters, function(k) {  ## For each k
#       cat(paste0("k = ", k, "\n"))
#       ## Run clustering
#       res <- get(paste0("apply_", method))(sce = sce, params = params, k = k)
# 
#       ## Put output in data frame
#       df <- data.frame(dataset = scename,
#                        method = method,
#                        cell = names(res$cluster),
#                        run = i,
#                        k = k,
#                        resolution = NA,
#                        cluster = res$cluster,
#                        stringsAsFactors = FALSE, row.names = NULL)
#       tm <- data.frame(dataset = scename,
#                        method = method,
#                        run = i,
#                        k = k,
#                        resolution = NA,
#                        user.self = res$st[["user.self"]],
#                        sys.self = res$st[["sys.self"]],
#                        user.child = res$st[["user.child"]],
#                        sys.child = res$st[["sys.child"]],
#                        elapsed = res$st[["elapsed"]],
#                        stringsAsFactors = FALSE, row.names = NULL)
#       kest <- data.frame(dataset = scename,
#                          method = method,
#                          run = i,
#                          k = k,
#                          resolution = NA,
#                          est_k = res$est_k,
#                          stringsAsFactors = FALSE, row.names = NULL)
#       list(clusters = df, timing = tm, kest = kest)
#     })  ## End for each k
#   }
# 
#   ## Summarize across different values of k
#   assignments <- do.call(rbind, lapply(tmp, function(w) w$clusters))
#   timings <- do.call(rbind, lapply(tmp, function(w) w$timing))
#   k_estimates <- do.call(rbind, lapply(tmp, function(w) w$kest))
#   list(assignments = assignments, timings = timings, k_estimates = k_estimates)
# })  ## End for each run
# 
# ## Summarize across different runs
# assignments <- do.call(rbind, lapply(L, function(w) w$assignments))
# timings <- do.call(rbind, lapply(L, function(w) w$timings))
# k_estimates <- do.call(rbind, lapply(L, function(w) w$k_estimates))
# 
# ## Add true group for each cell
# truth <- data.frame(cell = as.character(rownames(colData(sce))),
#                     trueclass = as.character(colData(sce)$phenoid),
#                     stringsAsFactors = FALSE)
# assignments$trueclass <- truth$trueclass[match(assignments$cell, truth$cell)]
# 
# ## Combine results
# res <- list(assignments = assignments, timings = timings,
#             k_estimates = k_estimates)
# 
# df <- dplyr::full_join(res$assignments %>%
#                          dplyr::select(dataset, method, cell, run, k,
#                                        resolution, cluster, trueclass),
#                        res$k_estimates %>%
#                          dplyr::select(dataset, method, run, k,
#                                        resolution, est_k)
# ) %>% dplyr::full_join(res$timings %>% dplyr::select(dataset, method, run, k,
#                                                      resolution, elapsed))

## -----------------------------------------------------------------------------
sessionInfo()

#' Help function for computing ARI
#'
#' @importFrom utils combn
#' @importFrom mclust adjustedRandIndex
#' @importFrom dplyr select
#' @importFrom stats median
#' @importFrom methods is
#'
#' @param x A \code{data.frame} with clustering results.
#'
#' @return a \code{data.frame} with ARI values for each pair of runs.
#'
ari_df <- function(x) {
  stopifnot(methods::is(x, "data.frame"))
  stopifnot(methods::is(x[, 1], "character"))

  x <- dplyr::select(x, -cell)
  columns <- utils::combn(ncol(x), 2)
  ari_nk <- array(NA, ncol(columns))
  for (i in seq_len(length(ari_nk))) {
    ari_nk[i] <- mclust::adjustedRandIndex(x[, columns[1, i]],
                                           x[, columns[2, i]])
  }
  data.frame(ari.stab = ari_nk, run1 = columns[1, ], run2 = columns[2, ],
             stringsAsFactors = FALSE)
}

#' Plot stability of methods
#'
#' Plot the stability of the clusterings obtained for each method
#'
#' @param res A data.frame with clustering results.
#' @param method_colors A named vector with colors to use for the different
#'   clustering methods. Can be NULL, in which case colors are chosen
#'   automatically.
#'
#' @export
#'
#' @author Angelo Duo, Charlotte Soneson
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr group_by select mutate summarize filter
#' @importFrom tidyr nest unnest separate
#' @importFrom purrr map_int map
#' @importFrom reshape2 dcast
#' @importFrom ggplot2 scale_colour_manual ggplot aes geom_line geom_vline
#'   theme_bw theme facet_grid ylim labs element_text element_blank geom_boxplot
#'   geom_tile coord_equal
#' @importFrom viridis scale_fill_viridis
#' @importFrom ggthemes theme_tufte
#' @importFrom utils data
#'
#' @return A named list of \code{ggplot2} objects
#'
#' @examples
#' res <- clustering_summary_filteredExpr10_Koh_v1()
#' plots <- plot_stability(res)
#'
plot_stability <- function(res, method_colors = NULL) {
  ## Initialize list to hold plots
  plots <- list()

  if (is.null(method_colors)) {
    manual_scale <- ggplot2::scale_colour_discrete(name = "")
  } else {
    manual_scale <- ggplot2::scale_colour_manual(name = "",
                                                 values = method_colors)
  }

  shared_theme <- list(
    ggplot2::theme_bw(),
    manual_scale,
    ggplot2::theme(legend.text = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   axis.title = ggplot2::element_text(size = 16),
                   axis.text = ggplot2::element_text(size = 13),
                   strip.text = ggplot2::element_text(size = 13)),
    ggplot2::facet_grid(filtering ~ dataset, scales = "free_x"),
    ggplot2::ylim(NA, 1)
  )

  ## Compute stability
  ## nest df
  res_summary <- res %>% dplyr::group_by(dataset, method, k) %>%
    tidyr::nest() %>%
    dplyr::mutate(truenclust = purrr::map_int(data, function(x) {
      length(unique(x$trueclass))
    }))

  ## wide format
  cast.map <-  function(x) {
    reshape2::dcast(x, cell ~ run, value.var = "cluster")
  }

  res_nested <- res_summary %>%
    dplyr::mutate(data.wide = purrr::map(data, cast.map))

  ## compute ARI
  res_stab.tmp <- res_nested %>%
    dplyr::mutate(stability = purrr::map(data.wide, ari_df))

  ## unnest
  res_stab <- res_stab.tmp %>%
    dplyr::select(dataset, method, k, stability, truenclust) %>%
    tidyr::unnest() %>%
    tidyr::separate(dataset, sep = "_", into = c("sce", "filtering",
                                                 "dataset")) %>%
    dplyr::select(-sce)
  res_stab$k <- as.integer(res_stab$k)

  ## methods combined
  plots[["stability_vs_k"]] <-
    ggplot2::ggplot(res_stab %>%
                      dplyr::group_by(dataset, method, filtering, k,
                                      truenclust) %>%
                      dplyr::summarize(ari.stab = stats::median(ari.stab,
                                                                na.rm = TRUE)),
                    ggplot2::aes(x = k, y = ari.stab, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_vline(aes(xintercept = truenclust), linetype = "dashed") +
    ggplot2::geom_line(size = 1) +
    ggplot2::labs(y = "Stability (ARI)", x = "Number of clusters") +
    ggplot2::theme(legend.position = "right")

  ## stability at truenclust
  plots[["stability_truek"]] <-
    ggplot2::ggplot(res_stab %>% dplyr::filter(k == truenclust),
                    ggplot2::aes(x = method, y = ari.stab, group = method,
                                 color = method)) +
    shared_theme +
    ggplot2::geom_boxplot() +
    ggplot2::labs(y = "Stability (ARI) at true number of clusters") +
    ggplot2::theme(axis.text.x = element_text(size = 13, angle = 90,
                                              hjust = 1, vjust = 0.5))

  ## plot heat map on median stability with truenclust
  plots[["stability_heatmap_truek"]] <-
    ggplot2::ggplot(res_stab %>% dplyr::filter(k == truenclust) %>%
                      dplyr::group_by(filtering, dataset, method, k) %>%
                      dplyr::summarise(
                        median.stability = stats::median(ari.stab)),
                    ggplot2::aes(x = stats::reorder(method, median.stability,
                                                    FUN = mean, na.rm = TRUE),
                                 y = stats::reorder(dataset, median.stability,
                                                    FUN = mean, na.rm = TRUE),
                                 fill = median.stability)) +
    ggplot2::geom_tile(color = "white", size = 0.5, na.rm = FALSE) +
    ggplot2::facet_wrap(~ filtering) +
    viridis::scale_fill_viridis(name = "Median \nstability \n(ARI)",
                                direction = -1,
                                limits = c(0, 1), na.value = "white") +
    ggthemes::theme_tufte(base_family = "Helvetica") +
    ggplot2::labs(x = NULL, y = NULL,
                  title = "median stability (ARI) at true number of clusters") +
    ggplot2::coord_equal() +
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 13, angle = 90,
                                                       hjust = 1, vjust = 0.5),
                   axis.text.y = ggplot2::element_text(size = 13),
                   legend.title = ggplot2::element_text(size = 16),
                   legend.title.align = 0,
                   legend.text = ggplot2::element_text(size = 13),
                   legend.position = "right",
                   legend.key.size = unit(2, "cm"),
                   legend.key.width = unit(0.5, "cm"),
                   axis.ticks = ggplot2::element_blank(),
                   strip.text = ggplot2::element_text(size = 16))

  plots
}

---
title: "Visualize data sets and clustering results with `iSEE`"
author: 
- name: Angelo Duò
- name: Mark D Robinson
- name: Charlotte Soneson
date: "`r Sys.Date()`"
package: DuoClustering2018
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Visualize data sets and clustering results with iSEE}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: duoclustering2018.bib
editor_options: 
  chunk_output_type: console
---

# Introduction

In this vignette we describe how to generate a `SingleCellExperiment` object
combining observed values and clustering results for a data set from the
`DuoClustering2018` package, and how the resulting object can be explored and
visualized with the `iSEE` package [@Rue-Albrecht2018-wz].

# Load the necessary packages

```{r}
suppressPackageStartupMessages({
  library(SingleCellExperiment)
  library(DuoClustering2018)
  library(dplyr)
  library(tidyr)
})
```

# Retrieve a data set

The different ways of retrieving a data set from the package are described in
the `plot_performance` vignette. Here, we will load a data set using the
shortcut function provided in the package.

```{r}
dat <- sce_filteredExpr10_Koh()
```

# Read a set of clustering results

For this data set, we also load a set of clustering results obtained using
different clustering methods.

```{r}
res <- clustering_summary_filteredExpr10_Koh_v2()
```

# Merge data and clustering results

We add the cluster labels for one run and for a set of different imposed number
of clusters to the data set.

```{r}
res <- res %>% dplyr::filter(run == 1 & k %in% c(3, 5, 9)) %>%
  dplyr::group_by(method, k) %>% 
  dplyr::filter(is.na(resolution) | resolution == resolution[1]) %>%
  dplyr::ungroup() %>% 
  tidyr::unite(col = method_k, method, k, sep = "_", remove = TRUE) %>% 
  dplyr::select(cell, method_k, cluster) %>%
  tidyr::spread(key = method_k, value = cluster)

colData(dat) <- DataFrame(
  as.data.frame(colData(dat)) %>%
    dplyr::left_join(res, by = c("Run" = "cell"))
)
head(colData(dat))
```

# Visualize with `iSEE`

The resulting `SingleCellExperiment` can be interactively explored using, e.g.,
the `iSEE` package. This can be useful to gain additional understanding of the
partitions inferred by the different clustering methods, to visualize these in
low-dimensional representations (PCA or t-SNE), and to investigate how well they
agree with known or inferred groupings of the cells.

```{r, eval=FALSE}
if (require(iSEE)) {
  iSEE(dat)
}
```

# Session info

```{r}
sessionInfo()
```

# References

---
title: "Apply clustering method"
author: 
- name: Angelo Duò
- name: Mark D Robinson
- name: Charlotte Soneson
date: "`r Sys.Date()`"
package: DuoClustering2018
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Apply clustering method}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: duoclustering2018.bib
editor_options: 
  chunk_output_type: console
---

# Introduction

This vignette describes how each of the included clustering methods was applied
to the collection of data sets in order to generate the clustering result
summaries provided with the package. It also shows how to apply a new clustering
method to the included data sets, to generate results that can be compared to
those already included.

# Applying a new clustering algorithm to a provided data set

The code below describes how we applied each of the included clustering methods
to the data sets for our paper [@Duo2018-F1000]. The `apply_*()` functions,
describing how the respective clustering methods were run, are available from
the [GitHub
repository](https://github.com/markrobinsonuzh/scRNAseq_clustering_comparison/tree/master/Rscripts/clustering)
corresponding to the publication. In order to apply a new clustering algorithm
to one of the data sets using the same framework, it is necessary to generate a
function with the same format. The input arguments to this function should be:

- a `SingleCellExperiment` object
- a named list of parameter values (can be empty, if no parameters are used for
the method)
- the desired number of clusters (k). 

The function should return a list with three elements:

- `st` - a vector with the timing information. Should have five elements, named
`user.self`, `sys.self`, `user.child`, `sys.child` and `elapsed`.
- `cluster` - a named vector of cluster assignments for all cells.
- `est_k` - the number of clusters estimated by the method (if available,
otherwise `NA`).

If the method does not allow specification of the desired number of clusters,
but has another parameter affecting the resolution, this can be accommodated as
well (see the solution for `Seurat` in the code below).

First, load the package and define the data set and clustering method to use
(note that in order to apply a method named `<method>`, there has to be a
function named `apply_<method>()`, with the above specifications, available in
the workspace).

```{r}
suppressPackageStartupMessages({
  library(DuoClustering2018)
})

scename <- "sce_filteredExpr10_Koh"
sce <- sce_filteredExpr10_Koh()
method <- "PCAHC"
```

Next, define the list of hyperparameter values. The package contains the
hyperparameter values for the methods included in our paper.

```{r}
## Load parameter files. General dataset and method parameters as well as
## dataset/method-specific parameters
params <- duo_clustering_all_parameter_settings_v2()[[paste0(scename, "_", 
                                                             method)]]
params
```

Finally, define the number of times to apply the clustering method (for each
value of the number of clusters), and run the clustering across a range of
imposed numbers of clusters (defined in the parameter list).

```{r, eval=FALSE}
## Set number of times to run clustering for each k
n_rep <- 5

## Run clustering
set.seed(1234)
L <- lapply(seq_len(n_rep), function(i) {  ## For each run
  cat(paste0("run = ", i, "\n"))
  if (method == "Seurat") {
    tmp <- lapply(params$range_resolutions, function(resolution) {  
      ## For each resolution
      cat(paste0("resolution = ", resolution, "\n"))
      ## Run clustering
      res <- get(paste0("apply_", method))(sce = sce, params = params, 
                                           resolution = resolution)
      
      ## Put output in data frame
      df <- data.frame(dataset = scename, 
                       method = method, 
                       cell = names(res$cluster),
                       run = i,
                       k = length(unique(res$cluster)),
                       resolution = resolution,
                       cluster = res$cluster,
                       stringsAsFactors = FALSE, row.names = NULL)
      tm <- data.frame(dataset = scename, 
                       method = method,
                       run = i, 
                       k = length(unique(res$cluster)),
                       resolution = resolution,
                       user.self = res$st[["user.self"]],
                       sys.self = res$st[["sys.self"]],
                       user.child = res$st[["user.child"]],
                       sys.child = res$st[["sys.child"]],
                       elapsed = res$st[["elapsed"]],
                       stringsAsFactors = FALSE, row.names = NULL)
      kest <- data.frame(dataset = scename, 
                         method = method,
                         run = i, 
                         k = length(unique(res$cluster)),
                         resolution = resolution,
                         est_k = res$est_k,
                         stringsAsFactors = FALSE, row.names = NULL)
      list(clusters = df, timing = tm, kest = kest)
    })  ## End for each resolution
  } else {
    tmp <- lapply(params$range_clusters, function(k) {  ## For each k
      cat(paste0("k = ", k, "\n"))
      ## Run clustering
      res <- get(paste0("apply_", method))(sce = sce, params = params, k = k)
      
      ## Put output in data frame
      df <- data.frame(dataset = scename, 
                       method = method, 
                       cell = names(res$cluster),
                       run = i,
                       k = k,
                       resolution = NA,
                       cluster = res$cluster,
                       stringsAsFactors = FALSE, row.names = NULL)
      tm <- data.frame(dataset = scename, 
                       method = method,
                       run = i, 
                       k = k,
                       resolution = NA,
                       user.self = res$st[["user.self"]],
                       sys.self = res$st[["sys.self"]],
                       user.child = res$st[["user.child"]],
                       sys.child = res$st[["sys.child"]],
                       elapsed = res$st[["elapsed"]],
                       stringsAsFactors = FALSE, row.names = NULL)
      kest <- data.frame(dataset = scename, 
                         method = method,
                         run = i, 
                         k = k,
                         resolution = NA,
                         est_k = res$est_k,
                         stringsAsFactors = FALSE, row.names = NULL)
      list(clusters = df, timing = tm, kest = kest)
    })  ## End for each k
  }
  
  ## Summarize across different values of k
  assignments <- do.call(rbind, lapply(tmp, function(w) w$clusters))
  timings <- do.call(rbind, lapply(tmp, function(w) w$timing))
  k_estimates <- do.call(rbind, lapply(tmp, function(w) w$kest))
  list(assignments = assignments, timings = timings, k_estimates = k_estimates)
})  ## End for each run

## Summarize across different runs
assignments <- do.call(rbind, lapply(L, function(w) w$assignments))
timings <- do.call(rbind, lapply(L, function(w) w$timings))
k_estimates <- do.call(rbind, lapply(L, function(w) w$k_estimates))

## Add true group for each cell
truth <- data.frame(cell = as.character(rownames(colData(sce))),
                    trueclass = as.character(colData(sce)$phenoid),
                    stringsAsFactors = FALSE)
assignments$trueclass <- truth$trueclass[match(assignments$cell, truth$cell)]

## Combine results
res <- list(assignments = assignments, timings = timings,
            k_estimates = k_estimates)

df <- dplyr::full_join(res$assignments %>%
                         dplyr::select(dataset, method, cell, run, k, 
                                       resolution, cluster, trueclass),
                       res$k_estimates %>%
                         dplyr::select(dataset, method, run, k, 
                                       resolution, est_k)
) %>% dplyr::full_join(res$timings %>% dplyr::select(dataset, method, run, k,
                                                     resolution, elapsed))
```

The resulting `df` data frames can then be combined across data sets, filterings
and methods and used as input to the provided plotting functions.

# Session info

```{r}
sessionInfo()
```

# References 

---
title: "Plot performance summaries"
author: 
- name: Angelo Duò
- name: Mark D Robinson
- name: Charlotte Soneson
date: "`r Sys.Date()`"
package: DuoClustering2018
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Plot performance summaries}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: duoclustering2018.bib
editor_options: 
  chunk_output_type: console
---

# Introduction

In this vignette we describe the basic usage of the `DuoClustering2018` package:
how to retrieve data sets and clustering results, and how to construct various
plots summarizing the performance of different methods across several data sets.

# Load the necessary packages

```{r}
suppressPackageStartupMessages({
  library(ExperimentHub)
  library(SingleCellExperiment)
  library(DuoClustering2018)
  library(plyr)
})
```

# Retrieve a data set

The clustering evaluation [@Duo2018-F1000] is based on 12 data sets (9 real and
3 simulated), which are all provided via `ExperimentHub` and retrievable via
this package. We include the full data sets (after quality filtering of cells
and removal of genes with zero counts across all cells) as well as three
filtered versions of each data set (by expression, variability and dropout
pattern, respectively), each containing 10% of the genes in the full data set.

To get an overview, we can list all records from this package that are available
in `ExperimentHub`:

```{r}
eh <- ExperimentHub()
query(eh, "DuoClustering2018")
```

The records with names starting in `sce_` represent (filtered or unfiltered)
data sets (in `SingleCellExperiment` format). The records with names starting in
`clustering_summary_` correspond to `data.frame` objects with clustering results
for each of the filtered data sets. Finally, the
`duo_clustering_all_parameter_settings` object contains the parameter settings
we used for all the clustering methods. For clustering summaries and parameter
settings, the version number (e.g., `_v2`) corresponds to the version of the
publication.

The records can be retrieved using their `ExperimentHub` ID, e.g.:

```{r}
eh[["EH1500"]]
```

Alternatively, the shortcut functions provided by this package can be used:

```{r}
sce_filteredExpr10_Koh()
```

# Read a set of clustering results

For each included data set, we have applied a range of clustering methods (see
the `run_clustering` vignette for more details on how this was done, and how to
apply additional methods). As mentioned above, the results of these clusterings
are also available from `ExperimentHub`, and can be loaded either by their
`ExperimentHub` ID or using the provided shortcut functions, as above. For
simplicity, the results of all methods for a given data set are combined into
a single object. As an illustration, we load the clustering summaries for two
different data sets (`Koh` and `Zhengmix4eq`), each with two different gene
filterings (`Expr10` and `HVG10`):

```{r}
res <- plyr::rbind.fill(
  clustering_summary_filteredExpr10_Koh_v2(),
  clustering_summary_filteredHVG10_Koh_v2(),
  clustering_summary_filteredExpr10_Zhengmix4eq_v2(),
  clustering_summary_filteredHVG10_Zhengmix4eq_v2()
)
dim(res)
```

The resulting `data.frame` contains 10 columns:

- `dataset`: The name of the data set
- `method`: The name of the clustering method
- `cell`: The cell identifier
- `run`: The run ID (each method was run five times for each data set and number
of clusters)
- `k`: The imposed number of clusters (for all methods except Seurat)
- `resolution`: The imposed resolution (only for Seurat)
- `cluster`: The assigned cluster label
- `trueclass`: The true class of the cell
- `est_k`: The estimated number of clusters (for methods allowing such
estimation)
- `elapsed`: The elapsed time of the run

```{r}
head(res)
```

# Define consistent method colors

For some of the plots generated below, the points will be colored according to
the clustering method. We can enforce a consistent set of colors for the methods
by defining a named vector of colors to use for all plots.

```{r}
method_colors <- c(CIDR = "#332288", FlowSOM = "#6699CC", PCAHC = "#88CCEE", 
            PCAKmeans = "#44AA99", pcaReduce = "#117733",
            RtsneKmeans = "#999933", Seurat = "#DDCC77", SC3svm = "#661100", 
            SC3 = "#CC6677", TSCAN = "grey34", ascend = "orange", SAFE = "black",
            monocle = "red", RaceID2 = "blue")
```

# Plot

Each plotting function described below returns a list of `ggplot` objects. These
can be plotted directly, or further modified if desired.

## Performance

The `plot_performance()` function generates plots related to the performance of
the clustering methods. We quantify performance using the adjusted Rand Index
(ARI) [@hubert1985comparing], comparing the obtained clustering to the true
clusters. As we noted in the publication [@Duo2018-F1000], defining a true
partitioning of the cells is difficult, since they can often be grouped together
in several different, but still interpretable, ways. We refer to our paper for
more information on how the true clusters were defined for each of the data
sets.

```{r}
perf <- plot_performance(res, method_colors = method_colors)
names(perf)
perf$median_ari_vs_k
perf$median_ari_heatmap_truek
```

## Stability

The `plot_stability()` function evaluates the stability of the clustering
results from each method, with respect to random starts. Each method was run
five times on each data set (for each k), and we quantify the stability by
comparing each pair of such runs using the adjusted Rand Index.

```{r}
stab <- plot_stability(res, method_colors = method_colors)
names(stab)
stab$stability_vs_k
stab$stability_heatmap_truek
```

## Entropy

In order to evaluate the tendency of the clustering methods to favor equally
sized clusters, we calculate the Shannon entropy [@Shannon1948-cw] of each
clustering solution (based on the proportions of cells in the different
clusters) and plot this using the `plot_entropy()` function. Since the maximal
entropy that can be obtained depends on the number of clusters, we use
normalized entropies, defined by dividing the observed entropy by `log2(k)`. We
also compare the entropies for the clusterings to the entropy of the true
partition for each data set.

```{r, fig.height = 8}
entr <- plot_entropy(res, method_colors = method_colors)
names(entr)
entr$entropy_vs_k
entr$normentropy
```

## Timing

The `plot_timing()` function plots various aspects of the timing of the
different methods.

```{r, fig.height = 8}
timing <- plot_timing(res, method_colors = method_colors, 
                      scaleMethod = "RtsneKmeans")
names(timing)
timing$time_normalized_by_ref
```

## Differences in k

Most performance evaluations above are performed on the clustering solutions
obtained by imposing the "true" number of clusters. The `plot_k_diff()` function
evaluates the difference between the true number of cluster and the number of
clusters giving the best agreement with the true partition, as well as the
difference between the estimated and the true number of clusters, for the
methods that allow estimation of k.

```{r, fig.height = 8}
kdiff <- plot_k_diff(res, method_colors = method_colors)
names(kdiff)
kdiff$diff_kest_ktrue
```

# Session info

```{r}
sessionInfo()
```

# References

---
title: "Import and QC of SimKumar data set"
output: html_document
editor_options: 
  chunk_output_type: console
---

```{r load-packages}
suppressPackageStartupMessages({
  library(MultiAssayExperiment)
  library(SingleCellExperiment)
  library(scater)
  library(scran)
  library(plyr)
  library(dplyr)
  library(ggplot2)
  library(splatter)
})
```

## Load MultiAssayExperiment object

```{r load-dataset}
(maex <- readRDS("../../data/data_raw/GSE60749-GPL13112.rds"))

## Extract the gene-level length-scaled TPMs
cts <- assays(experiments(maex)[["gene"]])[["count_lstpm"]]

## Extract the phenotype data.
phn <- colData(maex)
phn$phenoid <- as.character(interaction(as.data.frame(phn[, c("source_name_ch1",
                                                              "characteristics_ch1.1")])))
## Simplify labels
phn$phenoid <-  plyr::revalue(
  phn$phenoid, 
  c("Dgcr8 knockout mouse embryonic stem cells.culture conditions: serum+LIF" = "Dgcr8 knockout mouse serum+LIF", 
    "v6.5 mouse embryonic stem cells.culture conditions: 2i+LIF" = "v6.5 mouse 2i+LIF",
    "v6.5 mouse embryonic stem cells.culture conditions: serum+LIF" = "v6.5 mouse serum+LIF")
)
table(phn$phenoid)
```

## Extract one subpopulation

```{r}
stopifnot(all(colnames(cts) == rownames(phn)))

sub.cts <- cts[, phn$phenoid == "v6.5 mouse 2i+LIF"]
dim(sub.cts)
```

## Remove the ERCC spike-ins

```{r remove-spikes}
is.spike <- grepl("^ERCC", rownames(sub.cts))
sub.cts <- sub.cts[!is.spike, ]
```

## Estimate parameters for simulation

```{r estimate-parameters}
(params <- splatEstimate(sub.cts))
```

## Simulate new counts

```{r simulate-counts}
sce <- splatSimulate(params = params, batchCells = 500,
                     group.prob = c(0.13, 0.07, 0.1, 0.05, 0.4, 0.1, 0.1, 0.05), 
                     method = "groups", 
                     de.prob = c(0.03, 0.03, 0.03, 0.05, 0.05, 0.07, 0.08, 0.1),
                     verbose = FALSE)
sce <- normalise(sce, exprs_values = "counts", return_log = TRUE, 
                 return_norm_as_exprs = TRUE) ## generates logcounts(sce)
sce$phenoid <- colData(sce)$Group
```

Exclude features that are not expressed

```{r reduce-expression-matrix}
keep_features <- rowSums(counts(sce) > 0) > 0
table(keep_features)
sce <- sce[keep_features, ]
dim(sce)
```

## Calculate QC metrics

```{r QC}
sce <- calculateQCMetrics(sce)
```

## Quality control using PCA on column data

We create a PCA plot based the quality metrics for each cell, e.g., the total
number of reads and the total number of features.

```{r qc-pca}
sce <- scater::runPCA(sce, pca_data_input = "coldata")
scater::plotPCA(sce, colour_by = "phenoid")
```

## Filter cells

We remove cells with log-library sizes (or total features) that are more than 3
median absolute deviations (MADs) below the median log-library size (or total
features).

```{r histogram}
colData(sce)$libsize.drop <- isOutlier(sce$total_counts, nmads = 3, type = "lower", log = TRUE)
ggplot(as.data.frame(colData(sce)), aes(x = total_counts)) + 
  geom_histogram(bins = 20, fill = "grey80") + xlab("Total count") + 
  ylab("Number of cells") + 
  geom_vline(xintercept = min(sce$total_counts[!sce$libsize.drop]), 
             color = "red", linetype = "dashed") + 
  theme_bw()

colData(sce)$feature.drop <- isOutlier(sce$total_features, nmads = 3, type = "lower", log = TRUE)
ggplot(as.data.frame(colData(sce)), aes(x = total_features)) + 
  geom_histogram(bins = 20, fill = "grey80") + xlab("Number of detected features") + 
  ylab("Number of cells") + 
  geom_vline(xintercept = min(sce$total_features[!sce$feature.drop]), 
             color = "red", linetype = "dashed") + 
  theme_bw()
```

```{r filter-cells}
table(libsize = sce$libsize.drop, feature = sce$feature.drop)
sce <- sce[, !(sce$libsize.drop | sce$feature.drop)]
dim(sce)
```

## Quality control using highest expressed genes

```{r qc-filt}
plotQC(sce, type = "highest-expression", n = 50)
```

## Data normalization

```{r sizefactors}
sce <- computeSumFactors(sce, sizes = pmin(ncol(sce), seq(20, 120, 20)), min.mean = 0.1)
summary(sizeFactors(sce))
```

```{r normalization}
sce <- normalise(sce, exprs_values = "counts", return_log = TRUE, 
                 return_norm_as_exprs = TRUE)
sce <- normalise(sce, exprs_values = "counts", return_log = FALSE, 
                 return_norm_as_exprs = FALSE)
```

## Plot the proportion of explained variances

```{r explained-variance, warning = FALSE} 
expl_vars <- c("phenoid", "log10_total_counts", "log10_total_features", "pct_dropout",
               "pct_counts_top_200_features", "log10_counts_feature_controls",
               "pct_counts_feature_controls")
plotQC(sce, type = "explanatory-variables", variables = expl_vars)
```

## Plot t-SNE representations

```{r tSNE}
set.seed(1234)
sce <- runTSNE(sce, exprs_values = "logcounts", perplexity = 10)
plotTSNE(sce, colour_by = "phenoid")
plotTSNE(sce, colour_by = "total_features", size_by = "total_counts")
```

## Save the normalized and cell filtered dataset

```{r save-data}
dim(sce)
table(sce$phenoid)
saveRDS(sce, file = "../../data/sce_full/sce_full_SimKumar8hard.rds")
```

## Session info

```{r}
date()
sessionInfo()
```

---
title: "Import and QC of Zheng data set"
output: html_document
editor_options: 
  chunk_output_type: console
---

```{r load-packages}
suppressPackageStartupMessages({
  library(MultiAssayExperiment)
  library(SingleCellExperiment)
  library(scater)
  library(scran)
  library(dplyr)
  library(ggplot2)
})
```

## Load raw data

```{r load-dataset}
b.cells <- read10XResults("../../data/data_raw/zheng/b_cells/filtered_matrices_mex/hg19") 
naive.cytotoxic <- read10XResults("../../data/data_raw/zheng/naive_cytotoxic/filtered_matrices_mex/hg19")
cd14.monocytes <- read10XResults("../../data/data_raw/zheng/cd14_monocytes/filtered_matrices_mex/hg19")
regulatory.t <- read10XResults("../../data/data_raw/zheng/regulatory_t/filtered_matrices_mex/hg19")

colnames(b.cells) <-  paste0("b.cells", seq_len(ncol(b.cells)))
colnames(naive.cytotoxic) <- paste0("naive.cytotoxic", seq_len(ncol(naive.cytotoxic)))
colnames(cd14.monocytes) <- paste0("cd14.monocytes", seq_len(ncol(cd14.monocytes)))
colnames(regulatory.t) <- paste0("regulatory.t", seq_len(ncol(regulatory.t)))

colData(b.cells)$phenoid <- "b.cells"
colData(naive.cytotoxic)$phenoid <- "naive.cytotoxic"
colData(cd14.monocytes)$phenoid <- "cd14.monocytes"
colData(regulatory.t)$phenoid <- "regulatory.t"

## Subsample
set.seed(1234)
b.cells <- b.cells[, sample(colnames(b.cells), 1000, replace = FALSE)]
naive.cytotoxic <- naive.cytotoxic[, sample(colnames(naive.cytotoxic), 1000, replace = FALSE)]
cd14.monocytes <- cd14.monocytes[, sample(colnames(cd14.monocytes), 1000, replace = FALSE)]
regulatory.t <- regulatory.t[, sample(colnames(regulatory.t), 1000, replace = FALSE)]
```

## Create a SingleCellExperiment object

```{r create-sce}
sce <- cbind(b.cells, naive.cytotoxic, cd14.monocytes, regulatory.t)
counts(sce) <-  as.matrix(counts(sce))
sce <- normalise(sce, exprs_values = "counts", return_log = TRUE, 
                 return_norm_as_exprs = TRUE) ## generates logcounts(sce)
```

Exclude features that are not expressed

```{r reduce-expression-matrix}
keep_features <- rowSums(counts(sce) > 0) > 0
table(keep_features)
sce <- sce[keep_features, ]
dim(sce)
```

## Identify the remaining ERCC spike-ins.

```{r ercc-mt}
is.spike <- grepl("^ERCC", rowData(sce)$symbol)
table(is.spike)
summary(colSums(counts(sce[is.spike, ])))
```

## Calculate QC metrics

```{r QC}
sce <- calculateQCMetrics(sce)
```

## Quality control using PCA on column data

We create a PCA plot based the quality metrics for each cell, e.g., the total
number of reads, the total number of features and the proportion of spike-in
reads.

```{r qc-pca}
sce <- scater::runPCA(sce, pca_data_input = "coldata")
scater::plotPCA(sce, colour_by = "phenoid")
```

## Filter cells

We remove cells with log-library sizes (or total features) that are more than 3
median absolute deviations (MADs) below the median log-library size (or total
features).

```{r histogram}
colData(sce)$libsize.drop <- isOutlier(sce$total_counts, nmads = 3, type = "lower", log = TRUE)
ggplot(as.data.frame(colData(sce)), aes(x = total_counts)) + 
  geom_histogram(bins = 20, fill = "grey80") + xlab("Total count") + 
  ylab("Number of cells") + 
  geom_vline(xintercept = min(sce$total_counts[!sce$libsize.drop]), 
             color = "red", linetype = "dashed") + 
  theme_bw()

colData(sce)$feature.drop <- isOutlier(sce$total_features, nmads = 3, type = "lower", log = TRUE)
ggplot(as.data.frame(colData(sce)), aes(x = total_features)) + 
  geom_histogram(bins = 20, fill = "grey80") + xlab("Number of detected features") + 
  ylab("Number of cells") + 
  geom_vline(xintercept = min(sce$total_features[!sce$feature.drop]), 
             color = "red", linetype = "dashed") + 
  theme_bw()
```

```{r filter-cells}
table(libsize = sce$libsize.drop, feature = sce$feature.drop)
sce <- sce[, !(sce$libsize.drop | sce$feature.drop)]
dim(sce)
```

## Quality control using highest expressed genes

```{r qc-filt}
plotQC(sce, type = "highest-expression", n = 50)
```

## Data normalization

```{r normalization}
sce <- normalise(sce, exprs_values = "counts", return_log = TRUE, 
                 return_norm_as_exprs = TRUE)
sce <- normalise(sce, exprs_values = "counts", return_log = FALSE, 
                 return_norm_as_exprs = FALSE)
```

## Plot the proportion of explained variances

```{r explained-variance, warning = FALSE} 
expl_vars <- c("phenoid", "log10_total_counts", "log10_total_features", "pct_dropout",
               "pct_counts_top_200_features", "log10_counts_feature_controls",
               "pct_counts_feature_controls")
plotQC(sce, type = "explanatory-variables", variables = expl_vars)
```

## Plot t-SNE representations

```{r tSNE}
set.seed(1234)
sce <- runTSNE(sce, exprs_values = "logcounts", perplexity = 10)
plotTSNE(sce, colour_by = "phenoid")
plotTSNE(sce, colour_by = "total_features", size_by = "total_counts")
```

## Save the normalized and cell filtered dataset

```{r save-data}
sce <- sce[!grepl("^ERCC", rownames(sce)), ]
dim(sce)
table(sce$phenoid)
saveRDS(sce, file = "../../data/sce_full/sce_full_Zhengmix4eq.rds")
```

## Session info

```{r}
date()
sessionInfo()
```

---
title: "Downloading and processing raw data files"
author: ""
date: ""
output: html_document
---

Below, we summarize the process of generating the data sets and clustering
results provided in this package. More information is available from the GitHub
repository corresponding to the publication (Duò et al., F1000Research 7:1141
(2018)):
[https://github.com/markrobinsonuzh/scRNAseq_clustering_comparison](https://github.com/markrobinsonuzh/scRNAseq_clustering_comparison).

## Generating the data sets 

First, we download the raw data files, either from the conquer repository
[http://imlspenticton.uzh.ch:3838/conquer/](http://imlspenticton.uzh.ch:3838/conquer/)
or from the 10x Genomics website
[https://support.10xgenomics.com/single-cell-gene-expression/datasets](https://support.10xgenomics.com/single-cell-gene-expression/datasets).

```{bash, eval=FALSE}
wget -P data/data_raw http://imlspenticton.uzh.ch/robinson_lab/conquer/data-mae/GSE60749-GPL13112.rds
wget -P data/data_raw http://imlspenticton.uzh.ch/robinson_lab/conquer/data-mae/GSE52529-GPL16791.rds
wget -P data/data_raw http://imlspenticton.uzh.ch/robinson_lab/conquer/data-mae/SRP073808.rds
wget -O data/data_raw/SRP073808TCC.rds http://imlspenticton.uzh.ch/robinson_lab/conquer/data-tcc/SRP073808.rds
wget -O data/data_raw/GSE52529-GPL16791TCC.rds http://imlspenticton.uzh.ch/robinson_lab/conquer/data-tcc/GSE52529-GPL16791.rds
wget -O data/data_raw/GSE60749-GPL13112TCC.rds http://imlspenticton.uzh.ch/robinson_lab/conquer/data-tcc/GSE60749-GPL13112.rds

for D in b_cells naive_cytotoxic cd14_monocytes regulatory_t cd56_nk memory_t cd4_t_helper naive_t; do \
mkdir -p data/data_raw/zheng/${D}; \
wget -P data/data_raw/zheng http://cf.10xgenomics.com/samples/cell-exp/1.1.0/${D}/${D}_filtered_gene_bc_matrices.tar.gz; \
tar zxvf data/data_raw/zheng/${D}_filtered_gene_bc_matrices.tar.gz -C data/data_raw/zheng/${D}; \
rm -f data/data_raw/zheng/${D}_filtered_gene_bc_matrices.tar.gz; \
done

```

Next, we run each `import_QC_*.Rmd` file to generate the "full" data sets
(retaining all genes with at least 1 read in at least one of the good-quality
cells). From the "full" data sets, we then generate the filtered data sets using
the following wrapper code:

```{r, eval=FALSE}
suppressPackageStartupMessages({
  library(SingleCellExperiment)
  library(scater)
  library(Seurat)
  library(scran)
  library(M3Drop)
})

sce <- readRDS(scefile)

sce_filt <- get(paste0("filter", method))(sce = sce, pctkeep = pctkeep)

sce_filt <- calculateQCMetrics(sce_filt)
sce_filt <- computeSumFactors(sce_filt, sizes = pmin(ncol(sce_filt), 
                                                     seq(20, 120, 20)), 
                              min.mean = 0.5)
table(sizeFactors(sce_filt) < 0)
sce_filt <- sce_filt[, sizeFactors(sce_filt) > 0]
sce_filt <- normalise(sce_filt, exprs_values = "counts", return_log = TRUE, 
                      return_norm_as_exprs = TRUE)
sce_filt <- normalise(sce_filt, exprs_values = "counts", return_log = FALSE, 
                      return_norm_as_exprs = FALSE)
sce_filt <- runTSNE(sce_filt, exprs_values = "logcounts", perplexity = 10)

saveRDS(sce_filt, file = outrds)
```

We use three filtering methods (indicated by `method` in the code chunk above):
`Expr`, `HVG` and `M3Drop`. The percentage of genes to keep (`pctkeep`) is
always 10.

```{r, eval=FALSE}
## Expr filtering
filterExpr <- function(sce, pctkeep) {
  exprsn <- rowMeans(logcounts(sce))
  keep <- order(exprsn, decreasing = TRUE)[seq_len(pctkeep/100*length(exprsn))]
  sce[keep, ]
}

## HVG filtering
filterHVG <- function(sce, pctkeep) {
  seurat <- CreateSeuratObject(raw.data = counts(sce), 
                               meta.data = as.data.frame(colData(sce)),
                               min.cells = 0, min.genes = 0, 
                               project = "scRNAseq")
  seurat <- NormalizeData(seurat)
  seurat <- ScaleData(seurat, vars.to.regress = "nUMI", 
                      display.progress = FALSE)
  seurat <- FindVariableGenes(seurat, do.plot = FALSE)
  keep <- rownames(head(seurat@hvg.info, n = round(pctkeep/100*nrow(sce))))
  sce[keep, ]
}

## M3Drop filtering
filterM3Drop <- function(sce, pctkeep) {
  cpm <- calculateCPM(sce)
  cpm <- cpm[rowMeans(cpm) > 0.05, ]
  res <- M3DropDifferentialExpression(expr_mat = cpm, 
                                      mt_method = "none", mt_threshold = 1, 
                                      suppress.plot = TRUE)
  res <- res[order(res$p.value), ]
  stopifnot(nrow(res) > round(pctkeep/100*nrow(sce)))
  keep <- rownames(head(res, n = round(pctkeep/100*nrow(sce))))
  sce[keep, ]
}
```

## Running the clustering algorithms

The clustering results were obtained by running a number of clustering
algorithms on each of the data sets generated above. The details can be found in
the GitHub repository corresponding to the publication (Duò et al.,
F1000Research 7:1141 (2018)):
[https://github.com/markrobinsonuzh/scRNAseq_clustering_comparison](https://github.com/markrobinsonuzh/scRNAseq_clustering_comparison).
The vignette `run_clustering.Rmd` contains the wrapper script that we used to
apply each clustering function to each data set. It is also reproduced here. The
specific clustering functions (called `apply_*()`) can be found in the GitHub
repository of the publication. The parameter settings are included in summarized
form in this package (`duo_clustering_all_parameter_settings_v1()`).

```{r, eval=FALSE}
print(scefile)  ## Name of .rds file containing a SingleCellExperiment object
print(method)  ## Clustering method
print(outrds)  ## Name of .rds file where results will be written

suppressPackageStartupMessages({
  library(rjson)
  library(SingleCellExperiment)
})
source(paste0("Rscripts/clustering/apply_", method, ".R"))

## Load parameter files. General dataset and method parameters as well as
## dataset/method-specific parameters
params <- c(fromJSON(file = paste0("parameter_settings/", 
                                   gsub("\\.rds$", "_", basename(scefile)), 
                                   method, ".json")),
            fromJSON(file = paste0("parameter_settings/", method, ".json")), 
            fromJSON(file = paste0("parameter_settings/", 
                                   gsub("\\.rds$", ".json", basename(scefile))))
            )
## If any parameter is repeated, take the most specific
if (any(duplicated(names(params)))) {
  warning("Possibly conflicting settings")
  params <- params[!duplicated(names(params))]
}
print(params)

## Set number of times to run clustering for each k
n_rep <- 5

## Read data
sce <- readRDS(scefile)

## Run clustering
set.seed(1234)
L <- lapply(seq_len(n_rep), function(i) {  ## For each run
  cat(paste0("run = ", i, "\n"))
  if (method == "Seurat") {
    tmp <- lapply(params$range_resolutions, function(resolution) {  ## For each resolution
      cat(paste0("resolution = ", resolution, "\n"))
      ## Run clustering
      res <- get(paste0("apply_", method))(sce = sce, params = params, 
                                           resolution = resolution)
      
      ## Put output in data frame
      df <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                       method = method, 
                       cell = names(res$cluster),
                       run = i,
                       k = length(unique(res$cluster)),
                       resolution = resolution,
                       cluster = res$cluster,
                       stringsAsFactors = FALSE, row.names = NULL)
      tm <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                       method = method,
                       run = i, 
                       k = length(unique(res$cluster)),
                       resolution = resolution,
                       user.self = res$st[["user.self"]],
                       sys.self = res$st[["sys.self"]],
                       user.child = res$st[["user.child"]],
                       sys.child = res$st[["sys.child"]],
                       elapsed = res$st[["elapsed"]],
                       stringsAsFactors = FALSE, row.names = NULL)
      kest <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                         method = method,
                         run = i, 
                         k = length(unique(res$cluster)),
                         resolution = resolution,
                         est_k = res$est_k,
                         stringsAsFactors = FALSE, row.names = NULL)
      list(clusters = df, timing = tm, kest = kest)
    })  ## End for each resolution
  } else {
    tmp <- lapply(params$range_clusters, function(k) {  ## For each k
      cat(paste0("k = ", k, "\n"))
      ## Run clustering
      res <- get(paste0("apply_", method))(sce = sce, params = params, k = k)
      
      ## Put output in data frame
      df <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                       method = method, 
                       cell = names(res$cluster),
                       run = i,
                       k = k,
                       resolution = NA,
                       cluster = res$cluster,
                       stringsAsFactors = FALSE, row.names = NULL)
      tm <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                       method = method,
                       run = i, 
                       k = k,
                       resolution = NA,
                       user.self = res$st[["user.self"]],
                       sys.self = res$st[["sys.self"]],
                       user.child = res$st[["user.child"]],
                       sys.child = res$st[["sys.child"]],
                       elapsed = res$st[["elapsed"]],
                       stringsAsFactors = FALSE, row.names = NULL)
      kest <- data.frame(dataset = gsub("\\.rds$", "", basename(scefile)), 
                         method = method,
                         run = i, 
                         k = k,
                         resolution = NA,
                         est_k = res$est_k,
                         stringsAsFactors = FALSE, row.names = NULL)
      list(clusters = df, timing = tm, kest = kest)
    })  ## End for each k
  }
  
  ## Summarize across different values of k
  assignments <- do.call(rbind, lapply(tmp, function(w) w$clusters))
  timings <- do.call(rbind, lapply(tmp, function(w) w$timing))
  k_estimates <- do.call(rbind, lapply(tmp, function(w) w$kest))
  list(assignments = assignments, timings = timings, k_estimates = k_estimates)
})  ## End for each run

## Summarize across different runs
assignments <- do.call(rbind, lapply(L, function(w) w$assignments))
timings <- do.call(rbind, lapply(L, function(w) w$timings))
k_estimates <- do.call(rbind, lapply(L, function(w) w$k_estimates))

## Add true group for each cell
truth <- data.frame(cell = as.character(rownames(colData(sce))),
                    trueclass = as.character(colData(sce)$phenoid),
                    stringsAsFactors = FALSE)
assignments$trueclass <- truth$trueclass[match(assignments$cell, truth$cell)]

## Save results
saveRDS(list(assignments = assignments, timings = timings,
             k_estimates = k_estimates), file = outrds)
```

\name{sce_full_Koh}
\docType{data}
\alias{sce_full_Koh}
\alias{sce_filteredExpr10_Koh}
\alias{sce_filteredHVG10_Koh}
\alias{sce_filteredM3Drop10_Koh}
\alias{sce_full_KohTCC}
\alias{sce_filteredExpr10_KohTCC}
\alias{sce_filteredHVG10_KohTCC}
\alias{sce_filteredM3Drop10_KohTCC}

\title{
Koh data sets
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Gene or TCC counts for a scRNA-seq data set from Koh et al. (2016), consisting
of in vitro cultured
H7 embryonic stem cells (WiCell) and H7-derived downstream early mesoderm
progenitors.
}
\details{
This is a scRNA-seq data set originally from Koh et al. (2016). The data set
consists of
gene-level read counts or TCCs (transcript compatibility counts)
of in vitro cultured human H7 embryonic stem cells (WiCell) and
H7-derived downstream
early mesoderm progenitors. It contains 9 subpopulations, defined by the
cell phenotype given by the authors' annotations. The data sets have been used
to evaluate the performance of clustering algorithms in Duò et al. (2018).

For the \code{sce_full_Koh} data set, all genes except those with zero counts
across all cells are retained. The gene counts are
gene-level length-scaled TPM values derived from Salmon (Patro et al. (2017))
quantifications (see
Soneson and Robinson (2018)). For the TCC data set we estimated transcripts
compatibility counts using \code{kallisto} as an alternative to the gene-level
count matrix (Bray et al. (2016), Ntranos et al. (2016)).

The \code{scater} package was used to perform quality control of the data sets
(McCarthy et al. (2017)).
Features with zero counts across all cells, as well as all cells with total
count or total number
of detected features more than 3 median absolute deviations (MADs) below the
median across all cells (on the log scale), were excluded.

The \code{sce_full_Koh} data set consists of 531 cells and 48,981 features,
and the \code{sce_full_KohTCC} data set of 531 cells and 811,938 features.
The \code{filteredExpr}, \code{filteredHVG} and \code{filteredM3Drop10} are
further reduced data sets.
For each of the filtering methods, we retained 10 percent of the number of genes
(with a non-zero count in at least one cell) in the original data sets.

For the \code{filteredExpr} data sets, only the genes/TCCs with the highest
average expression (log-normalized count) value across all cells were retained.
Using the \code{Seurat} package (Satija et al. (2015)), the \code{filteredHVG}
data sets were filtered on the variability of the features and only the most
highly variable ones were retained. Finally, the \code{M3Drop} package was
used to model the dropout rate of the genes as a function of the mean
expression level using the Michaelis-Menten equation and select variables to
retain for the \code{filteredM3Drop10} data sets (Andrews and Hemberg (2018)).

The \code{scater} package was used to normalize the count values, based on
normalization factors calculated by the deconvolution method from the
\code{scran} package (Lun et al. (2016)).

This data set is provided as a \code{SingleCellExperiment} object
(Lun and Risso (2017)). Raw data files for the original data set (SRP073808)
are available from https://www.ncbi.nlm.nih.gov/sra?term=SRP073808.}

\usage{
sce_full_Koh(metadata = FALSE)
sce_filteredExpr10_Koh(metadata = FALSE)
sce_filteredHVG10_Koh(metadata = FALSE)
sce_filteredM3Drop10_Koh(metadata = FALSE)
sce_full_KohTCC(metadata = FALSE)
sce_filteredExpr10_KohTCC(metadata = FALSE)
sce_filteredHVG10_KohTCC(metadata = FALSE)
sce_filteredM3Drop10_KohTCC(metadata = FALSE)
}

\examples{
sce_filteredHVG10_Koh()
}
\format{SingleCellExperiment}
\value{Returns a \code{SingleCellExperiment} object.}
\references{
Andrews, T.S., and Hemberg, M. (2018). \emph{Dropout-based feature selection for
scRNASeq}. bioRxiv doi:https://doi.org/10.1101/065094.

Bray, N.L., Pimentel, H., Melsted, P., and Pachter, L. (2016).
\emph{Near-optimal probabilistic RNA-seq quantification}.
Nat. Biotechnol. 34: 525–527.

Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for single-cell
RNA-seq data.}
F1000Res. 7:1141.

Koh, P.W., Sinha, R., Barkal, A.A., Morganti  R.M., Chen, A., Weissman, I.L.,
Ang, L.T., Kundaje, A., and Loh, K.M. (2016).
\emph{An atlas of transcriptional, chromatin accessibility, and surface marker
changes in human mesoderm development.}
Scientific Data 3:160109.

Lun, A.T.L., Bach, K., and Marioni, J.C. (2016) \emph{Pooling across cells to
normalize single-cell RNA sequencing data with many zero counts.}
Genome Biol. 17(1): 75.

Lun, A.T.L., and Risso, D. (2017). \emph{SingleCellExperiment: S4 Classes for
Single Cell Data}. R package version 1.0.0.

McCarthy, D.J., Campbell, K.R., Lun, A.T.L., and Wills, Q.F. (2017):
\emph{Scater: pre-processing, quality control, normalization and visualization
of single-cell RNA-seq data in R.} Bioinformatics 33(8): 1179-1186.

Ntranos, V., Kamath, G.M., Zhang, J.M., Pachter, L., and Tse, D.N. (2016):
\emph{Fast and accurate single-cell RNA-seq analysis by clustering of
transcript-compatibility counts.} Genome Biol. 17:112.

Patro, R., Duggal, G., Love, M.I., Irizarry, R.A., and Kingsford, C. (2017):
\emph{Salmon provides fast and bias-aware quantification of transcript
expression.} Nat. Methods 14:417-419.

Satija, R., Farrell, J.A., Gennert, D., Schier, A.F., and Regev, A. (2015).
\emph{Spatial reconstruction of single-cell gene expression data.}
Nat. Biotechnol. 33(5): 495–502.

Soneson, C., and Robinson, M.D. (2018). \emph{Bias, robustness and scalability
in single-cell differential expression analysis.} Nat. Methods, 15(4): 255-261.
}
\keyword{datasets}

\name{sce_full_Zhengmix4eq}
\docType{data}
\alias{sce_full_Zhengmix4eq}
\alias{sce_filteredExpr10_Zhengmix4eq}
\alias{sce_filteredHVG10_Zhengmix4eq}
\alias{sce_filteredM3Drop10_Zhengmix4eq}
\alias{sce_full_Zhengmix4uneq}
\alias{sce_filteredExpr10_Zhengmix4uneq}
\alias{sce_filteredHVG10_Zhengmix4uneq}
\alias{sce_filteredM3Drop10_Zhengmix4uneq}
\alias{sce_full_Zhengmix8eq}
\alias{sce_filteredExpr10_Zhengmix8eq}
\alias{sce_filteredHVG10_Zhengmix8eq}
\alias{sce_filteredM3Drop10_Zhengmix8eq}
\title{
Zheng data sets
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Gene counts for scRNA-seq data sets from Zheng et al. (2017), consisting of
pre-sorted cell types combined into three artificial data sets with different
cell proportions.
}
\details{
This is a scRNA-seq data set originally from Zheng et al. (2017). The data set
consists of eight pre-sorted cell types (B-cells, naive cytotoxic T-cells, CD14
monocytes, regulatory T-cells, CD56 NK cells, memory T-cells, CD4 T-helper cells
and naive T-cells) from \emph{Homo sapiens} combined into three artificial data
sets with different cell proportions. The annotated cell type (obtained by
pre-sorting of the cells) is used as the true cell label. The data sets have
been used to evaluate the performance of clustering algorithms in Duò et al.
(2018).

For the \code{Zhengmix4eq} data set, randomly selected B-cells, CD14 monocytes,
naive cytotoxic T-cells and regulatory T-cells were combined in equal
proportions (1,000 cells per subpopulation).
The \code{Zhengmix4uneq} data set consists of four cell types, combined in
unequal proportions (1,000 B-cells, 500 naive cytotoxic T-cells, 2,000 CD14
monocytes and 3,000 regulatory T-cells). For the \code{Zhengmix8eq} data set,
all eight populations were combined in approximately equal proportions (400–600
cells per population).

For the \code{sce_full_Zhengmix4eq}, \code{sce_full_Zhengmix4uneq} and
\code{sce_full_Zhengmix8eq} data set, all genes except those with zero counts
across all cells are retained. The gene counts are unique molecular
identifiers (UMIs) counts.
The \code{scater} package was used to perform quality control of the data
(McCarthy et al. (2017)).
Features with zero counts across all cells, as well as all cells with total
count or total number of detected features more than 3 median absolute
deviations (MADs) below the median across all cells (on the log scale),
were excluded.

The \code{sce_full_Zhengmix4eq} data set consists of 3,994 cells and 15,568
features, the \code{sce_full_Zhengmix4uneq} data set of 6,498 cells and 16,443
features and the \code{sce_full_Zhengmix8eq} of 3,994 cells and 16,443 features,
respectively.
The \code{filteredExpr}, \code{filteredHVG} and \code{filteredM3Drop10} are
further reduced data sets.
For each of the filtering method, we retained 10 percent of the original
number of genes
(with a non-zero count in at least one cell) in the original data sets.

For the \code{filteredExpr} data sets, only the genes with the highest average
expression (log-normalized count) value across all cells were retained.
Using the \code{Seurat} package, the \code{filteredHVG} data sets were filtered
on the variability of the features and only the most highly variable ones were
retained (Satija et al. (2015)).  Finally, the \code{M3Drop} package was used
to model the dropout rate of the genes as a function of the mean expression
level using the Michaelis-Menten equation and select variables to retain for the
\code{filteredM3Drop10} data sets (Andrews and Hemberg (2018)).

The \code{scater} package was used to normalize the count values, based on
normalization factors calculated by the deconvolution method from the
\code{scran} package (Lun et al. (2016)).
This data set is provided as a \code{SingleCellExperiment} object
(Lun and Risso (2017)). For further information on the
\code{SingleCellExperiment} class, see the corresponding manual.
Raw data files or the original data sets are available from
https://support.10xgenomics.com/single-cell-gene-expression/datasets.}

\usage{
sce_full_Zhengmix4eq(metadata = FALSE)
sce_filteredExpr10_Zhengmix4eq(metadata = FALSE)
sce_filteredHVG10_Zhengmix4eq(metadata = FALSE)
sce_filteredM3Drop10_Zhengmix4eq(metadata = FALSE)
sce_full_Zhengmix4uneq(metadata = FALSE)
sce_filteredExpr10_Zhengmix4uneq(metadata = FALSE)
sce_filteredHVG10_Zhengmix4uneq(metadata = FALSE)
sce_filteredM3Drop10_Zhengmix4uneq(metadata = FALSE)
sce_full_Zhengmix8eq(metadata = FALSE)
sce_filteredExpr10_Zhengmix8eq(metadata = FALSE)
sce_filteredHVG10_Zhengmix8eq(metadata = FALSE)
sce_filteredM3Drop10_Zhengmix8eq(metadata = FALSE)
}
\examples{
sce_filteredExpr10_Zhengmix4eq()
}
\format{SingleCellExperiment}
\value{Returns a \code{SingleCellExperiment} object.}
\references{
Andrews, T.S., and Hemberg, M. (2018). \emph{Dropout-based feature selection for
scRNASeq}. bioRxiv doi:https://doi.org/10.1101/065094.

Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for single-cell
RNA-seq data.}
F1000Res. 7:1141.

Lun, A.T.L., Bach, K., and Marioni, J.C. (2016) \emph{Pooling across cells to
normalize single-cell RNA sequencing data with many zero counts.}
Genome Biol. 17(1): 75.

Lun, A.T.L., and Risso, D. (2017). \emph{SingleCellExperiment: S4 Classes for
Single Cell Data}. R package version 1.0.0.

McCarthy, D.J., Campbell, K.R., Lun, A.T.L., and Wills, Q.F. (2017):
\emph{Scater: pre-processing, quality control, normalization and visualization
of single-cell RNA-seq data in R.} Bioinformatics 33(8): 1179-1186.

Satija, R., Farrell, J.A., Gennert, D., Schier, A.F., and Regev, A. (2015).
\emph{Spatial reconstruction of single-cell gene expression data.}
Nat. Biotechnol. 33(5): 495–502.

Zheng, G.X., Terry, J.M., Belgrader P., Ryvkin, Pl, Bent, Z.W., Wilson, R.,
Ziraldo, S.B., Wheeler, T.D., McDermott, G.P., Zhu, J., Gregory, M.T.,
Shuga, J., Montesclaros, L., Underwood, J.G., Masquelier, D.A., Nishimura, S.Y.,
Schnall-Levin, M., Wyatt, P.W., Hindson, C.M., Bharadwaj, R., Wong, A.,
Ness, K.D., Beppu, L.W., Deeg, H.J., McFarland, C., Loeb, K.R., Valente, W.J.,
Ericson, N.G., Stevens, E.A., Radich, J.P., Mikkelsen, T.S., Hindson, B.J.,
and Bielas, J.H. (2017). \emph{Massively parallel
digital transcriptional profiling of single cells.} Nat. Commun. 8:14049.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_entropy.R
\name{shannon_entropy}
\alias{shannon_entropy}
\title{Calculate Shannon entropy}
\usage{
shannon_entropy(cluster_assignments)
}
\arguments{
\item{cluster_assignments}{A vector with cluster assignments}
}
\value{
The Shannon entropy of the assignment vector
}
\description{
Calculate Shannon entropy
}

\name{sce_full_SimKumar4easy}
\docType{data}
\alias{sce_full_SimKumar4easy}
\alias{sce_filteredExpr10_SimKumar4easy}
\alias{sce_filteredHVG10_SimKumar4easy}
\alias{sce_filteredM3Drop10_SimKumar4easy}
\alias{sce_full_SimKumar4hard}
\alias{sce_filteredExpr10_SimKumar4hard}
\alias{sce_filteredHVG10_SimKumar4hard}
\alias{sce_filteredM3Drop10_SimKumar4hard}
\alias{sce_full_SimKumar8hard}
\alias{sce_filteredExpr10_SimKumar8hard}
\alias{sce_filteredHVG10_SimKumar8hard}
\alias{sce_filteredM3Drop10_SimKumar8hard}


\title{
SimKumar data sets
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Gene counts for scRNA-seq data sets simulated with the \code{splatter} package.
}
\details{
Using one subpopulation of the \code{sce_full_Kumar} data set as input,
scRNA-seq data with known group structure was simulated with the \code{splatter}
package from Zappia et al. (2017). The simulated data have been used to evaluate
the performance of clustering algorithms in Duò et al. (2018).

Three data sets have been generated, each consisting of 500 cells and
approximately 43,000 features, with varying degree of cluster separability.
The \code{sce_full_SimKumar4easy} data set consists of 4 subpopulations with
relative abundances 0.1, 0.15, 0.5 and 0.25, and probabilities of differential
expression set to 0.05, 0.1, 0.2 and 0.4 for the four subpopulations,
respectively. The \code{sce_full_SimKumar4hard} data set consists of 4
subpopulations with relative abundances 0.2, 0.15, 0.4 and 0.25, and
probabilities of differential expression 0.01, 0.05, 0.05 and 0.08. Finally,
the \code{sce_full_SimKumar8hard} data set consists of 8 subpopulations with
relative abundances 0.13, 0.07, 0.1, 0.05, 0.4, 0.1, 0.1 and 0.05, and
probabilities of differential expression equal to 0.03, 0.03, 0.03, 0.05, 0.05,
0.07, 0.08 and 0.1, respectively.

The \code{scater} package was used to perform quality control of the data sets
(McCarthy et al. (2017)).
Features with zero counts across all cells, as well as cells with total count
or total number of detected features more than 3 median absolute deviations
(MADs) below the median across all cells (on the log scale), were excluded.
The \code{filteredExpr}, \code{filteredHVG} and \code{filteredM3Drop10} are
further reduced data sets. For each of the filtering method, we retained 10
percent of the original number of genes
(with a non-zero count in at least one cell) in the original data sets.

For the \code{filteredExpr} data sets, only the genes with the highest average
expression (log-normalized count) value across all cells were retained.
Using the \code{Seurat} package, the \code{filteredHVG} data sets were filtered
on the variability of the features and only the most highly variable ones were
retained (Satija et al. (2015)).  Finally, the \code{M3Drop} package was used
to model the dropout rate of the genes as a function of the mean expression
level using the Michaelis-Menten equation and select variables to retain for
the \code{filteredM3Drop10} data sets (Andrews and Hemberg (2018)).

The \code{scater} package was used to normalize the count values, based on
normalization factors calculated by the deconvolution method from the
\code{scran} package (Lun et al. (2016)).
This data set is provided as a \code{SingleCellExperiment} object
(Lun and Risso (2017)). For further information on the
\code{SingleCellExperiment} class, see the corresponding manual. }

\usage{
sce_full_SimKumar4easy(metadata = FALSE)
sce_filteredExpr10_SimKumar4easy(metadata = FALSE)
sce_filteredHVG10_SimKumar4easy(metadata = FALSE)
sce_filteredM3Drop10_SimKumar4easy(metadata = FALSE)
sce_full_SimKumar4hard(metadata = FALSE)
sce_filteredExpr10_SimKumar4hard(metadata = FALSE)
sce_filteredHVG10_SimKumar4hard(metadata = FALSE)
sce_filteredM3Drop10_SimKumar4hard(metadata = FALSE)
sce_full_SimKumar8hard(metadata = FALSE)
sce_filteredExpr10_SimKumar8hard(metadata = FALSE)
sce_filteredHVG10_SimKumar8hard(metadata = FALSE)
sce_filteredM3Drop10_SimKumar8hard(metadata = FALSE)
}
\examples{
sce_filteredExpr10_SimKumar4easy()
}
\format{SingleCellExperiment}
\value{Returns a \code{SingleCellExperiment} object.}
\references{
Andrews, T.S., and Hemberg, M. (2018). \emph{Dropout-based feature selection
for scRNASeq}. bioRxiv doi:https://doi.org/10.1101/065094.

Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for single-cell
RNA-seq data.}
F1000Res. 7:1141.

Lun, A.T.L., Bach, K., and Marioni, J.C. (2016) \emph{Pooling across cells to
normalize single-cell RNA sequencing data with many zero counts.}
Genome Biol. 17(1): 75.

Lun, A.T.L., and Risso, D. (2017). \emph{SingleCellExperiment: S4 Classes for
Single Cell Data}. R package version 1.0.0.

McCarthy, D.J., Campbell, K.R., Lun, A.T.L., and Wills, Q.F. (2017):
\emph{Scater: pre-processing, quality control, normalization and visualization
of single-cell RNA-seq data in R.} Bioinformatics 33(8): 1179-1186.

Satija, R., Farrell, J.A., Gennert, D., Schier, A.F., and Regev, A. (2015).
\emph{Spatial reconstruction of single-cell gene expression data.}
Nat. Biotechnol. 33(5): 495–502.

Zappia, L., Phipson, B., and Oshlack, A. (2017). \emph{Splatter: simulation of
single-cell RNA sequencing data.} Genome Biol. 18(1): 174.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_stability.R
\name{ari_df}
\alias{ari_df}
\title{Help function for computing ARI}
\usage{
ari_df(x)
}
\arguments{
\item{x}{A \code{data.frame} with clustering results.}
}
\value{
a \code{data.frame} with ARI values for each pair of runs.
}
\description{
Help function for computing ARI
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_timing.R
\name{plot_timing}
\alias{plot_timing}
\title{Plot timing of methods}
\usage{
plot_timing(res, method_colors = NULL, scaleMethod = NULL)
}
\arguments{
\item{res}{A data.frame with clustering results.}

\item{method_colors}{A named vector with colors to use for the different
clustering methods. Can be NULL, in which case colors are chosen
automatically.}

\item{scaleMethod}{Either NULL or one of the clustering methods in the result
data.frame. If not NULL, a plot will be generated where all elapsed times
are normalized by dividing with the time for \code{scaleMethod}. If NULL,
this plot will not be generated.}
}
\value{
A named list of ggplot2 objects
}
\description{
Plot the elapsed time for each clustering method
}
\examples{
res <- clustering_summary_filteredExpr10_Koh_v1()
plots <- plot_timing(res)

}
\author{
Angelo Duo, Charlotte Soneson
}

\name{clustering_summary_filteredExpr10_Koh_v1}
\docType{data}
\alias{clustering_summary_filteredExpr10_Koh_v1}
\alias{clustering_summary_filteredHVG10_Koh_v1}
\alias{clustering_summary_filteredM3Drop10_Koh_v1}
\alias{clustering_summary_filteredExpr10_KohTCC_v1}
\alias{clustering_summary_filteredHVG10_KohTCC_v1}
\alias{clustering_summary_filteredM3Drop10_KohTCC_v1}
\alias{clustering_summary_filteredExpr10_Kumar_v1}
\alias{clustering_summary_filteredHVG10_Kumar_v1}
\alias{clustering_summary_filteredM3Drop10_Kumar_v1}
\alias{clustering_summary_filteredExpr10_KumarTCC_v1}
\alias{clustering_summary_filteredHVG10_KumarTCC_v1}
\alias{clustering_summary_filteredM3Drop10_KumarTCC_v1}
\alias{clustering_summary_filteredExpr10_Trapnell_v1}
\alias{clustering_summary_filteredHVG10_Trapnell_v1}
\alias{clustering_summary_filteredM3Drop10_Trapnell_v1}
\alias{clustering_summary_filteredExpr10_TrapnellTCC_v1}
\alias{clustering_summary_filteredHVG10_TrapnellTCC_v1}
\alias{clustering_summary_filteredM3Drop10_TrapnellTCC_v1}
\alias{clustering_summary_filteredExpr10_Zhengmix4eq_v1}
\alias{clustering_summary_filteredHVG10_Zhengmix4eq_v1}
\alias{clustering_summary_filteredM3Drop10_Zhengmix4eq_v1}
\alias{clustering_summary_filteredExpr10_Zhengmix4uneq_v1}
\alias{clustering_summary_filteredHVG10_Zhengmix4uneq_v1}
\alias{clustering_summary_filteredM3Drop10_Zhengmix4uneq_v1}
\alias{clustering_summary_filteredExpr10_Zhengmix8eq_v1}
\alias{clustering_summary_filteredHVG10_Zhengmix8eq_v1}
\alias{clustering_summary_filteredM3Drop10_Zhengmix8eq_v1}
\alias{clustering_summary_filteredExpr10_SimKumar4easy_v1}
\alias{clustering_summary_filteredHVG10_SimKumar4easy_v1}
\alias{clustering_summary_filteredM3Drop10_SimKumar4easy_v1}
\alias{clustering_summary_filteredExpr10_SimKumar4hard_v1}
\alias{clustering_summary_filteredHVG10_SimKumar4hard_v1}
\alias{clustering_summary_filteredM3Drop10_SimKumar4hard_v1}
\alias{clustering_summary_filteredExpr10_SimKumar8hard_v1}
\alias{clustering_summary_filteredHVG10_SimKumar8hard_v1}
\alias{clustering_summary_filteredM3Drop10_SimKumar8hard_v1}

\title{
Clustering summaries
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Clustering results for the performance evaluation of clustering methods for
scRNA-seq data, corresponding to v1 of Duò et al. (2018).
}
\details{
These objects contain clustering results from the performance evaluation of
clustering methods for scRNA-seq data. The clustering results are provided as
a \code{data.frame} object containing 10 variables (columns) named
\code{dataset}, \code{method}, \code{cell}, \code{run}, \code{k},
\code{resolution}, \code{cluster}, \code{trueclass}, \code{est_k} and
\code{elapsed}. For further information see Duò et al. (2018).}

\usage{
clustering_summary_filteredExpr10_Koh_v1(metadata = FALSE)
}
\examples{
clustering_summary_filteredExpr10_Koh_v1()
}
\value{Returns a \code{data.frame}.}
\references{
Duò A, Robinson MD. and Soneson C. (2018).
\emph{A systematic performance evaluation of clustering methods for
single-cell RNA-seq data.}
F1000Res., 7:1141.
}
\keyword{datasets}

\name{duo_clustering_all_parameter_settings_v2}
\alias{duo_clustering_all_parameter_settings_v2}

\title{
Hyperparameter values
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Hyperparameter values for all clustering algorithms and data sets in
v2 of Duo et al (F1000Research 2018)
}
\details{
List of hyperparameter values used for all clustering algorithms and
data sets in v2 of Duò et al (F1000Research 2018).
}
\usage{
duo_clustering_all_parameter_settings_v2(metadata = FALSE)
}
\examples{
duo_clustering_all_parameter_settings_v2()
}
\value{Returns a \code{list} with hyperparameter values for all data sets and
methods.}
\references{
Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for
single-cell RNA-seq data.}
F1000Research, 7:1141.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_stability.R
\name{plot_stability}
\alias{plot_stability}
\title{Plot stability of methods}
\usage{
plot_stability(res, method_colors = NULL)
}
\arguments{
\item{res}{A data.frame with clustering results.}

\item{method_colors}{A named vector with colors to use for the different
clustering methods. Can be NULL, in which case colors are chosen
automatically.}
}
\value{
A named list of \code{ggplot2} objects
}
\description{
Plot the stability of the clusterings obtained for each method
}
\examples{
res <- clustering_summary_filteredExpr10_Koh_v1()
plots <- plot_stability(res)

}
\author{
Angelo Duo, Charlotte Soneson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_performance.R
\name{plot_performance}
\alias{plot_performance}
\title{Plot performance of clustering methods}
\usage{
plot_performance(res, method_colors = NULL)
}
\arguments{
\item{res}{A data.frame with clustering results.}

\item{method_colors}{A named vector with colors to use for the different
clustering methods. Can be NULL, in which case colors are chosen
automatically.}
}
\value{
A named list of \code{ggplot2} objects
}
\description{
Generate various plots of the agreement between each clustering and the true
partitioning of the cells, quantified by the adjusted Rand index (ARI).
}
\examples{
res <- clustering_summary_filteredExpr10_Koh_v1()
plots <- plot_performance(res)

}
\author{
Angelo Duo, Charlotte Soneson
}

\name{sce_full_Trapnell}
\docType{data}
\alias{sce_full_Trapnell}
\alias{sce_filteredExpr10_Trapnell}
\alias{sce_filteredHVG10_Trapnell}
\alias{sce_filteredM3Drop10_Trapnell}
\alias{sce_full_TrapnellTCC}
\alias{sce_filteredExpr10_TrapnellTCC}
\alias{sce_filteredHVG10_TrapnellTCC}
\alias{sce_filteredM3Drop10_TrapnellTCC}

\title{
Trapnell data sets
}
\arguments{
\item{metadata}{Logical, whether only metadata should be returned}
}
\description{
Gene or TCC counts for scRNA-seq data set from Trapnell et al. (2014),
consisting of primary myoblasts over a time course of serum-induced
differentiation.
}
\details{
This is a scRNA-seq data set originally from Trapnell et al. (2014). The data
set consists of gene-level read counts or TCCs (transcript compatibility counts)
from human primary myoblasts over a time course of serum-induced
differentiation. It contains 3 subpopulations, defined by the cell phenotype
given by the authors' annotations. The data sets have been used to evaluate the
performance of clustering algorithms in Duò et al. (2018).

For the \code{sce_full_Trapnell} data set, all genes except those with zero
counts across all cells are retained. The gene counts are
gene-level length-scaled TPM values derived from Salmon (Patro et al. (2017))
quantifications (see
Soneson and Robinson (2018)). For the TCC data set we estimated transcripts
compatibility counts using \code{kallisto} as an alternative to the gene-level
count matrix (Bray et al. (2016), Ntranos et al. (2016)).

The \code{scater} package was used to perform quality control of the data sets
(McCarthy et al. (2017)).
Features with zero counts across all cells, as well as all cells with total
count or total number of detected features more than 3 median absolute
deviations (MADs) below the median across all cells (on the log scale),
were excluded. Additionally, cells that were classified as doublets or
debris were filtered out.

The \code{sce_full_Trapnell} data set consists of 222 cells and 41,111 features,
the \code{sce_full_TrapnellTCC} data set of 227 cells and 684,953 features,
respectively.
The \code{filteredExpr}, \code{filteredHVG} and \code{filteredM3Drop10} are
further reduced data sets.
For each of the filtering method, we retained 10 percent of the original
number of genes
(with a non-zero count in at least one cell) in the original data sets.

For the \code{filteredExpr} data sets, only the genes/TCCs with the highest
average expression (log-normalized count) value across all cells were retained.
Using the \code{Seurat} package, the \code{filteredHVG} data sets were filtered
on the variability of the features and only the most highly variable ones were
retained (Satija et al. (2015)). Finally, the \code{M3Drop} package was used
to model the dropout rate of the genes as a function of the mean expression
level using the Michaelis-Menten equation and select variables to retain for
the \code{filteredM3Drop10} data sets (Andrews and Hemberg (2018)).

The \code{scater} package was used to normalize the count values, based on
normalization factors calculated by the deconvolution method from the
\code{scran} package (Lun et al. (2016)).

This data set is provided as a \code{SingleCellExperiment} object
(Lun and Risso (2017)). For further information on the
\code{SingleCellExperiment} class, see the corresponding manual.
Raw data files for the original data set (GSE52529) are available from
https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52529.}

\usage{
sce_full_Trapnell(metadata = FALSE)
sce_filteredExpr10_Trapnell(metadata = FALSE)
sce_filteredHVG10_Trapnell(metadata = FALSE)
sce_filteredM3Drop10_Trapnell(metadata = FALSE)
sce_full_TrapnellTCC(metadata = FALSE)
sce_filteredExpr10_TrapnellTCC(metadata = FALSE)
sce_filteredHVG10_TrapnellTCC(metadata = FALSE)
sce_filteredM3Drop10_TrapnellTCC(metadata = FALSE)
}
\examples{
sce_filteredExpr10_Trapnell()
}
\format{SingleCellExperiment}
\value{Returns a \code{SingleCellExperiment} object.}
\references{
Andrews, T.S., and Hemberg, M. (2018). \emph{Dropout-based feature selection
for scRNASeq}. bioRxiv doi:https://doi.org/10.1101/065094.

Bray, N.L., Pimentel, H., Melsted, P., and Pachter, L. (2016).
\emph{Near-optimal probabilistic RNA-seq quantification}.
Nat. Biotechnol. 34: 525–527.

Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for single-cell
RNA-seq data.}
F1000Res. 7:1141.

Lun, A.T.L., Bach, K., and Marioni, J.C. (2016) \emph{Pooling across cells to
normalize single-cell RNA sequencing data with many zero counts.}
Genome Biol. 17(1): 75.

Lun, A.T.L., and Risso, D. (2017). \emph{SingleCellExperiment: S4 Classes for
Single Cell Data}. R package version 1.0.0.

McCarthy, D.J., Campbell, K.R., Lun, A.T.L., and Wills, Q.F. (2017):
\emph{Scater: pre-processing, quality control, normalization and visualization
of single-cell RNA-seq data in R.} Bioinformatics 33(8): 1179-1186.

Ntranos, V., Kamath, G.M., Zhang, J.M., Pachter, L., and Tse, D.N. (2016):
\emph{Fast and accurate single-cell RNA-seq analysis by clustering of
transcript-compatibility counts.} Genome Biol. 17:112.

Patro, R., Duggal, G., Love, M.I., Irizarry, R.A., and Kingsford, C. (2017):
\emph{Salmon provides fast and bias-aware quantification of transcript
expression.} Nat. Methods 14:417-419.

Satija, R., Farrell, J.A., Gennert, D., Schier, A.F., and Regev, A. (2015).
\emph{Spatial reconstruction of single-cell gene expression data.}
Nat. Biotechnol. 33(5): 495–502.

Soneson, C., and Robinson, M.D. (2018). \emph{Bias, robustness and scalability
in single-cell differential expression analysis.} Nat. Methods, 15(4): 255-261.

Trapnell, C., Cacchiarelli, D., Grimsby, J., Pokharel, P., Li, S., Morse, M.,
Lennon, N.J., Livak, K.J., Mikkelsen, T.S., and Rinn, J.L. (2014).
\emph{The dynamics and regulators of cell fate decisions are revealed by
pseudotemporal ordering of single cells.} Nat. Biotechnol. 32(4): 381–386.
}
\keyword{datasets}

\name{DuoClustering2018}
\docType{package}
\alias{DuoClustering2018}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
DuoClustering2018
}
\description{
Data package containing scRNA-seq data sets, clustering results and functions
for summarizing the performance of different scRNA-seq clustering methods.
}

\details{
This package contains publicly available scRNA-seq data sets and the
accompanying results from clustering using general-purpose methods and scRNA-seq
clustering methods. Several real data sets a well as simulated data sets are
provided. The data sets have been used to evaluate the performance of clustering
algorithms in our previous work and publication (Duò et al.,
F1000Research 2018). The data sets are available as
\code{SingleCellExperiment} objects. For additional details on the data
sets, see the help files for the respective data sets.

Additionally, the clustering results from the evaluation as well as functions
for summarization and visualization of the clustering results are provided.

A description of the basic usage of the package for retrieving data sets and
clustering results, and how to construct various plots summarizing the
performance of different methods is outlined in the package vignettes.
}
\author{
Angelo Duò and Charlotte Sonesson
}
\references{
Duò, A., Robinson, M.D., and Soneson, C. (2018).
\emph{A systematic performance evaluation of clustering methods for
single-cell RNA-seq data.}
F1000Research, 7:1141.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_k_diff.R
\name{plot_k_diff}
\alias{plot_k_diff}
\title{Plot differences between optimal, estimated and true number of clusters}
\usage{
plot_k_diff(res, method_colors = NULL)
}
\arguments{
\item{res}{A data.frame with clustering results.}

\item{method_colors}{A named vector with colors to use for the different
clustering methods. Can be NULL, in which case colors are chosen
automatically.}
}
\value{
A named list of ggplot2 objects
}
\description{
Plot differences between optimal, estimated and true number of clusters
}
\examples{
res <- clustering_summary_filteredExpr10_Koh_v1()
plots <- plot_k_diff(res)

}
\author{
Angelo Duo, Charlotte Soneson
}
